#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <dir.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <time.h>
#include <alloc.h>
#include <mem.h>
#include "dram.h"
#include "futil.h"

#define TRUE    1
#define FALSE   0

unsigned _ovrbuffer;
int ems_flag;

LONGINTEGER loops_per_ms;
LONGINTEGER loops_per_char;

void stack_probe(void)
{
}

extern void make_a_msg_sticky(char *);
extern void delete_messages(char *);
extern void renumber_messages(char *);
extern void prt_line(void);
extern void global_access_lvl_chg(void);
extern void clear_acctng_totals(void);
extern int fgets_p(char *,int,FILE *);

int is_legal_mailbox_name(char *,char *,int,char *,unsigned long);
void erase_mailbox(USER_RECORD *,unsigned long);
void main(void);
char *calcdate(INTEGER);
void add_user(void);
void process_city_state(DRAM *);
void build_ctl(void);
void build_user_ctl(void);
int import_user_msg(char *);
void import_msg(char *);
char *trim(char *);
void delete(char *,int,int);
void insert(char *,char *,int);
void proper(char *);
void pas_to_c(char *,char *,int);
void copy_p(char *,char *,int);
int pos(char *,char *);
long integer_input(char *);
void integer_ed(char *,int,LONGINTEGER *,int);
char bool_input(char *);
char *bool_print(char);
char *tf_print(char);
char char_input(char *);
void process_pathname(char *);
void import_error(char *,char *);
void build_error(char *,char *,BOOLEAN);
void re_organize(void);
void examine_lost(void);
char *backup_file(char *,char *,char *,char *);
void pause_to_read(BOOLEAN);
int strip_nl(char *,int);
int chg_dir(char *);
void expand_msg_idx(char *);
void clean_up_user_msg_file(char *,int);
void clean_up_board_joins(char *);
void up_gets(char *);
char *build_date2000(int,int,int);

extern unsigned _stklen = 32768U;

OLD_USER_RECORD old_user_rec;
char default_msg_path[128];
char gtpath[128];
char bbs_path[128];
char mailbox_dir[128];
char lan_path[128];

struct tnode {
    LONGINTEGER CallerNumber;
    LONGINTEGER HashCode;
    struct tnode *left;
    struct tnode *right;
};

static struct tnode *root          = NULL;
static int join_file                   = 0;

struct tnode *talloc(void)
{
    return((struct tnode *) malloc(sizeof(struct tnode)));
}

struct tnode *tree(struct tnode *p,LONGINTEGER cn,LONGINTEGER hc)
{
    if (p == NULL) {
	p = talloc();
	p->CallerNumber = cn;
	p->HashCode = hc;
	p->left = NULL;
	p->right = NULL;
    }
    else {
	if (cn < p->CallerNumber) {
	    p->left = tree(p->left,cn,hc);
	}
	else {
	    if (cn > p->CallerNumber)
		p->right = tree(p->right,cn,hc);
	}
    }
    return(p);
}

void tree_erase(struct tnode *p)
{
    if (p != NULL) {
	tree_erase(p->left);
	tree_erase(p->right);
	free(p);
    }
}

struct join_record {
    LONGINTEGER CallerNumber;
    LONGINTEGER HashCode;
};

struct join_record callers[256];
static int caller_count                = 0;
static char joins_dir[]                = "JOINS";

void add_board(LONGINTEGER cn,LONGINTEGER hc)
{
    callers[caller_count].CallerNumber = cn;
    callers[caller_count].HashCode     = hc;
    if (++caller_count > 255) {
	_write(join_file,&callers,2048);
	caller_count = 0;
	memset(&callers,0,2048);
    }
}

void traverse(struct tnode *p)
{
    if (p != NULL) {
	add_board(p->CallerNumber,p->HashCode);
	traverse(p->right);
	traverse(p->left);
    }
}

void FileDelete(char *fpath,char *fname)
{
    char work[128];
    char dpath[128];
    char far *dta;
    int result;
    struct ffblk ffblk;

    if (fpath[0])
	sprintf(work,"%s%s",fpath,fname);
    else
	strcpy(work,fname);
    dta = getdta();
    result = findfirst(work,&ffblk,0);
    while (result >= 0) {
	setdta(dta);
	if (ffblk.ff_name[0] != '.') {
	    if (fpath[0])
		sprintf(dpath,"%s%s",fpath,ffblk.ff_name);
	    else
		strcpy(dpath,ffblk.ff_name);
	    unlink(dpath);
	}
	result = findnext(&ffblk);
    }
    setdta(dta);
}

void select_path(char *s)
{
    if (strcmp(lan_path,gtpath))
	sprintf(s,"%s%s",lan_path,joins_dir);
     else
	sprintf(s,"%s%s",gtpath,joins_dir);
}

void wf_printf(char *fmt,...)
{
    va_list argptr;

    va_start(argptr,fmt);
    vprintf(fmt,argptr);
    va_end(argptr);
}

void WinDelay(int t)
{
    delay(t);
}

void mak_dir(char *s)
{
    int j;
    char temp[128];

    strcpy(temp,s);
    if ((j = strlen(temp) - 1) <= 0)
        return;
    if (temp[j] == '\\')
        temp[j] = 0;
    mkdir(temp);
}

void create_board_join(char *board_name)
{
    char bd_name[128], f_name[128], j_dname[128];

#ifdef DEBUG
    stack_probe();
#endif
    caller_count = 0;
    memset(&callers,0,2048);
    if ((!board_name[0]) || (board_name[0]==' '))
	return;
    strcpy(bd_name,board_name);
    bd_name[8] = 0;
    strupr(bd_name);
    select_path(j_dname);
    mak_dir(j_dname);
    sprintf(f_name,"%s\\%s.CTL",j_dname,bd_name);
    join_file = _creat(f_name,0);
    if (join_file < 0)
	return;
    traverse(root);
    if (caller_count)
	_write(join_file,&callers,2048);
    _close(join_file);
}

char *build_time(int h,int m)
{
    static char function[16];

    sprintf(function,"%2d:%02d",h,m);
    return(function);
}

long TZone = 0L;

void TZ(void)
{
    char *ep;
    int k;
    char tzstr[128];

    daylight = 0;
    timezone = 0L;
    if ((ep = getenv("TZ")) == NULL) {
Default:
	TZone = 28800L;
	return;
    }
    strcpy(tzstr,ep);
    if ((k = strlen(tzstr) - 1) < 3)
	goto Default;
    TZone = atol(&tzstr[3]) * 3600L;
    if ((tzstr[k] < '0')||(tzstr[k] > '9'))
	TZone -= 3600L;
}

long GMT(long local)
{
    return( local + TZone );
}

struct tm LCT(long gmt)
{
    struct tm local;
    time_t wk;

    wk = gmt - TZone;
    local = *(gmtime(&wk));
    return(local);
}

INTEGER daynumber(char *s)
{
    char inp[32];
    int month, day, year, slen, hold;
    struct tm dos_tm;

    slen = strlen(s);
    if (slen != 8)
	return(0);
    strcpy(inp,s);
    day    = atoi(&inp[6]);
    inp[6] = 0;
    month  = atoi(&inp[4]);
    inp[4] = 0;
    year   = atoi(&inp[0]);
    if (month > 12) {
        hold = month;
        month = day;
        day = hold;
    }
    if ((month < 1)||(month > 12)||(year < 0)||(day < 1)||(day > 31))
	return(0);
    if (year < 80)
	year += 100;
    if (year > 1900)
	year -= 1900;
    if ((year < 80) || (year > 179))
	return(0);
    dos_tm.tm_year = year;
    dos_tm.tm_mon  = month - 1;
    dos_tm.tm_mday  = day;
    dos_tm.tm_hour =
     dos_tm.tm_min  =
      dos_tm.tm_sec  =
       dos_tm.tm_isdst =
	dos_tm.tm_wday =
	 dos_tm.tm_yday = 0;
    timezone = daylight = 0;
    return( ((INTEGER)((mktime(&dos_tm)/86400L)+25569L-29221L)) );
}

int my_getkey(int bksp)
{
    int ky;

    if ((ky = getch()) == 8) {
	if (!bksp)
	    printf("\x08 \x08");
    }
    else {
        if (ky != 13)
            printf("%c",ky);
    }
    return(ky);
}

int chg_dir(char *p)
{
    char temp[128];
    char wrk[128];
    int j, deslash_it;

    if (!p[0])
	return(0);
    getcwd(temp,80);
    strcpy(wrk,p);
    strupr(wrk);
    deslash_it = 1;
    if (wrk[1] == ':') {
	setdisk((wrk[0] - 'A'));
	if (!wrk[2]) {
	    strcat(wrk,"\\");
	    deslash_it = 0;
	}
    }
    if (deslash_it) {
	if ((j = strlen(wrk) - 1) > 0)
	    if (wrk[j] == '\\')
		wrk[j] = 0;
    }
    if (chdir(wrk)) {
	chg_dir(temp);
	return(-1);
    }
    return(0);
}

int is_blank(int ch)
{
    int ch1;

    ch1 = (ch & 0x00ff);
    return( ((ch1==' ')||(ch1=='\t')||(ch1==0x00ff)) );
}

int is_blank_line(char *s)
{
    int j, ch;

    j = 0;
    while (ch = s[j++]) {
	if ((ch == '\r')||(ch == '\n'))
	    return(1);
	if (!is_blank(ch))
	    return(0);
    }
    return(1);
}

char *backup_file(char *pth,char *fn,char *ext,char *n_fn)
{
    static char wrk3[128];
    char wrk1[128];
    char wrk2[128];
    char fnm[128];
    char n_fnm[128];

    sprintf(fnm,"%s%s",pth,fn);
    sprintf(n_fnm,"%s%s",pth,n_fn);
    sprintf(wrk1,"%s.%s",n_fnm,ext);
    if (fexist(wrk1))
	unlink(wrk1);
    sprintf(wrk2,"REN  %s.%s  %s.%s",fnm,ext,n_fn,ext);
    printf("%s\n",wrk2);
    system(wrk2);
    sprintf(wrk3,"%s%s.%s",pth,n_fn,ext);
    return(wrk3);
}

void process_pathname(char *p)
{
    int lgth;

    if (p[0]) {
	strupr(p);
	lgth = strlen(p) - 1;
	if (p[lgth] == '\n')
	    p[lgth--] = 0;
	if (p[lgth] == '\r')
	    p[lgth--] = 0;
	if (p[lgth++] != '\\') {
	    p[lgth++] = '\\';
	    p[lgth] = 0;
	}
	if (p[0] == '\\')
	    return;
	while ( (p[0]) && ((p[0] < 'A') || (p[0] > 'Z')) )
	    delete(p,1,1);
    }
}

/****************************************************************************
void pas_to_c(char *cstr,char *pstr,int imax)
{
    int j;

    if ((j = pstr[0]) > imax)
	j = imax;
    memmove(cstr,(char *) &pstr[1],j);
    cstr[j] = 0;
}
****************************************************************************/

void pause_to_read(BOOLEAN pause)
{
    char estr[128];

    if (pause) {
	printf("\nPress [Enter] to continue...");
	gets(estr);
    }
}

void import_error(char *iname,char *ipath)
{

    printf("\nERROR: The %s%s.IDX file cannot be found.",ipath,iname);
    printf("\n       Perhaps an import needs to be performed.\n");
    pause_to_read(TRUE);
}

void build_error(char *bpath,char *bname,BOOLEAN pause)
{
    printf("\nERROR: The %s%s file cannot be opened.\n",bpath,bname);
    pause_to_read(pause);
}

void postal_code_adj(char *s)
{
    int i, nbr, blnk, pt;

    pt =
      blnk =
        nbr = 0;
    i = strlen(s);
    while ((i > 0) && (!nbr)) {
        if ((s[i]>='0')&&(s[i]<='9'))
            nbr = 1;
        else
            i--;
    }
    if (!nbr)
        return;
    while ((i > 0) && (!blnk)) {
        if ((s[i] == ' ')||(s[i] == ','))
            blnk = 1;
        else
            i--;
    }
//*******************************************
    pt = i;
    nbr =
      blnk = 0;
    while ((i > 0) && (!nbr)) {
        if ((s[i]>='0')&&(s[i]<='9'))
            nbr = 1;
        else
            i--;
    }
    if (!nbr) {
        i = pt;
        goto PostalUPPER;
    }
    while ((i > 0) && (!blnk)) {
        if (s[i] == ' ')
            blnk = 1;
        else
            i--;
    }
PostalUPPER:
    while (s[i]) {
        s[i] = toupper(s[i]);
        i++;
    }
}

void process_city_state(DRAM *fcb)
{
    char wrk_string[128];
    int j;
    USER_RECORD *p;

    p = fcb->user_rec;
    proper(p->user_city_state_zip);
    postal_code_adj(p->user_city_state_zip);
    strcpy(wrk_string,p->user_city_state_zip);
    wrk_string[4] = 0;
    strupr(wrk_string);
    if ((! strcmp(wrk_string,"HOU "))
	|| (! strcmp(wrk_string,"HOU."))
	    || (! strcmp(wrk_string,"HOU,"))) {
		strcpy(p->user_city_state_zip,"Houston, Tx");
		return;
    }
    if ((! strcmp(wrk_string,"PHX "))
	|| (! strcmp(wrk_string,"PHX."))
	    || (! strcmp(wrk_string,"PHX,"))) {
		strcpy(p->user_city_state_zip,"Phoenix, Az");
		return;
    }
    if ((j = pos("Texa",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Tx");
	return;
    }
    if ((j = pos("Hawai",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Hi");
	return;
    }
    if ((j = pos("Arizo",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Az");
	return;
    }
    if ((j = pos("Calif",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Ca");
	return;
    }
    if ((j = pos("Ohio",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Oh");
	return;
    }
    if ((j = pos("Utah",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Ut");
	return;
    }
    if ((j = pos("Illi",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Il");
	return;
    }
    if ((j = pos("Flori",p->user_city_state_zip)) > 1) {
	p->user_city_state_zip[j] = 0;
	strcat(p->user_city_state_zip,"Fl");
	return;
    }
    if (strcmp(wrk_string,"WASH")) {
	trim(p->user_city_state_zip);
	j = strlen(p->user_city_state_zip) - 1;
	if ((p->user_city_state_zip[j] == '.') || (p->user_city_state_zip[j] == ',')) {
	    p->user_city_state_zip[j] = 0;
	    proper(p->user_city_state_zip);
            postal_code_adj(p->user_city_state_zip);
	}
    }
}

void cvt_to_date2000(char *os,char *is)
{
    int m, d, y, j;
    int ds, ys;
    char ws[32];

    strcpy(ws,is);
    if (!ws[0])
        goto EarlyExit;
    j = pos("-",ws);
    if (j < 0) {
        j = pos("/",ws);
        if (j < 0) {
EarlyExit:
            os[0] = 0;
            return;
        }
    }
    ws[j] = ' ';
    ds = j + 1;
    j = pos("-",ws);
    if (j < 0) {
        j = pos("/",ws);
        if (j < 0)
            goto EarlyExit;
    }
    ws[j] = ' ';
    ys = j + 1;
    m = atoi(ws);
    d = atoi(&ws[ds]);
    y = atoi(&ws[ys]);
    strcpy(os,build_date2000(m,d,y));
}

char *fmt_date2000(char *is)
{
    static char date_buffer[16];

    if (is_blank_line(is)) {
        memset(date_buffer,0,sizeof(date_buffer));
        return(date_buffer);
    }
    date_buffer[0] = is[4];
    date_buffer[1] = is[5];

    date_buffer[2] =
      date_buffer[5] = '-';

    date_buffer[3] = is[6];
    date_buffer[4] = is[7];

    date_buffer[6] = is[0];
    date_buffer[7] = is[1];
    date_buffer[8] = is[2];
    date_buffer[9] = is[3];

    date_buffer[10] = 0;
    if (date_buffer[3] == '0')
        delete(date_buffer,4,1);
    if (date_buffer[0] == '0')
        delete(date_buffer,1,1);
    return(date_buffer);
}

char *fmt2_date2000(char *is)
{
    static char date_buffer[16];

    if (is_blank_line(is)) {
        memset(date_buffer,0,sizeof(date_buffer));
        return(date_buffer);
    }
    date_buffer[0] = is[4];
    date_buffer[1] = is[5];

    date_buffer[2] =
      date_buffer[5] = '-';

    date_buffer[3] = is[6];
    date_buffer[4] = is[7];

    date_buffer[6] = is[0];
    date_buffer[7] = is[1];
    date_buffer[8] = is[2];
    date_buffer[9] = is[3];

    date_buffer[10] = 0;
    if (date_buffer[0] == '0')
        date_buffer[0] = ' ';

    return(date_buffer);
}

void build_user_ctl(void)
{
    LONGINTEGER fpos, flen, counter;
    int inp_fileh;
    char inp_file[128];
    char work[128];
    DRAM *fcb;
    USER_RECORD *p;

    clrscr();
    printf("\nImporting: %sUSER.CTL -> %s_USER.CTL\n\n",lan_path,lan_path);
    sprintf(inp_file,"%sUSER.CTL",lan_path);
    if ((inp_fileh = _open(inp_file,O_RDWR)) < 0) {
	build_error(lan_path,"USER.CTL",TRUE);
	return;
    }
    fcb = allocate_fcb();
    p = fcb->user_rec;
    fcb->dat_recsize = sizeof(USER_RECORD);
    fcb->dat_keypos = 1;
    fcb->dat_keytype = 0;
    strcpy(fcb->dram_path,lan_path);
    dram_slasher(fcb);
    strcpy(fcb->dram_fname,"_USER");
    if (dram(CREATE,fcb)) {
	printf("\nERROR: Cannot create DRAM index and data file: %Fs%s",fcb->dram_path,"_USER");
	pause_to_read(TRUE);
	goto Bex;
    }
    flen = filelength(inp_fileh);
    fpos = (LONGINTEGER) sizeof(OLD_USER_RECORD);
    readfile(inp_fileh,(char*) &old_user_rec,sizeof(old_user_rec));
    memset(p,0,sizeof(USER_RECORD));
    p->user_caller_no = old_user_rec.old_user_caller_no;
    seekfile(fcb->dat_handle,0L,SEEK_SET);
    writefile(fcb->dat_handle,(char *) p,sizeof(USER_RECORD));
    counter = 0L;
    while (fpos < flen) {
	seekfile(inp_fileh,fpos,SEEK_SET);
	readfile(inp_fileh,(char*) &old_user_rec,sizeof(OLD_USER_RECORD));

	memset(p,0,sizeof(USER_RECORD));
	p->user_deleted = old_user_rec.old_user_deleted;
        old_user_rec.old_user_name[30] = 0;
	strcpy(p->user_name,old_user_rec.old_user_name);
	proper(p->user_name);

        old_user_rec.old_user_last_date[8] = 0;
	strcpy(work,old_user_rec.old_user_last_date);
        cvt_to_date2000(p->nf_last_date,work);
        old_user_rec.old_user_last_time[5] = 0;
	strcpy(p->user_last_time,old_user_rec.old_user_last_time);

        old_user_rec.old_user_first_date[8] = 0;
	strcpy(work,old_user_rec.old_user_first_date);
        cvt_to_date2000(p->nf_first_date,work);
        old_user_rec.old_user_first_time[5] = 0;
	strcpy(p->user_first_time,old_user_rec.old_user_first_time);

	p->user_netmail_credits = old_user_rec.old_user_credit;
	p->user_netmail_charges = old_user_rec.old_user_charges;
	p->user_total_calls = old_user_rec.old_user_times_on;
	p->user_banned = old_user_rec.old_user_banned;
	if (p->user_banned)
	    p->user_deleted = 0;
        p->user_expert = old_user_rec.old_user_expert;
        p->user_more = old_user_rec.old_user_more;
        old_user_rec.old_user_home[30] = 0;
        strcpy(p->user_city_state_zip,old_user_rec.old_user_home);
	process_city_state(fcb);
        old_user_rec.old_user_phone[10] = 0;
        strcpy(p->nf_phone,old_user_rec.old_user_phone);
        old_user_rec.old_user_password[20] = 0;
        strcpy(p->user_password,old_user_rec.old_user_password);
        p->nf_privel = old_user_rec.old_user_privel;
	p->user_day_calls = old_user_rec.old_user_day_calls;
        p->user_total_connect_time = old_user_rec.old_user_accum_time;
        p->user_day_connect_time   = old_user_rec.old_user_accum_time;
	p->user_protocol = old_user_rec.old_user_protocol;
	p->user_screen_lgth = old_user_rec.old_user_screen_lgth;
        p->user_total_upload_k = old_user_rec.old_user_upload_k;
        p->user_total_upload_files = old_user_rec.old_user_upload_files;
        p->user_total_dnload_k = old_user_rec.old_user_dnload_k;
        p->user_total_dnload_files = old_user_rec.old_user_dnload_files;
	p->user_caller_no = old_user_rec.old_user_caller_no;
        p->user_hash_code = old_user_rec.old_user_hash_code;
        old_user_rec.old_user_cb_handle[9] = 0;
        strcpy(p->user_cb_handle,old_user_rec.old_user_cb_handle);
        strcpy(p->nf_expire_date,calcdate(old_user_rec.old_user_expire_date));
        p->user_expired_privel = ' ';
        p->user_total_time_bank = old_user_rec.old_user_time_bank;
        p->user_day_dnload_k = old_user_rec.old_user_day_dnload_k;
        p->user_day_time_deposits = old_user_rec.old_user_day_time_deposits;
        p->user_day_time_withdrawals = old_user_rec.old_user_day_time_withdrawals;

	strcpy(fcb->string_key,p->user_name);
	fcb->binary_key = p->user_caller_no;
	if (dram(APPEND,fcb)) {
	    printf("Unable to add \"%Fs\", possible duplicate record.\n",p->user_name);
	    sleep(1);
	}
	else {
	    if (!(++counter % 25)) {
                printf("%5ld.  %-32Fs%-32Fs\n",p->user_caller_no,p->user_name,p->user_city_state_zip);
	    }
	}
	fpos += (LONGINTEGER) sizeof(OLD_USER_RECORD);
    }
    dram(CLOSE,fcb);
Bex:
    release_fcb(fcb);
    fcb=NULL;
    _close(inp_fileh);
}

/**********
void import_msg(char *msg_path)
{
    LONGINTEGER fpos, flen;
    int inp_fileh, out_fileh;
    char inp_file[128], out_file[128];
    struct msg_record old_msg_rec;
    struct msg_record new_msg_rec;

    printf("\nImporting: %sGTMESSAG.CTL -> %sMESSAGE.CTL\n\n",msg_path,msg_path);
    sprintf(inp_file,"%sGTMESSAG.CTL",msg_path);
    sprintf(out_file,"%sMESSAGE.CTL",msg_path);
    if ((inp_fileh = _open(inp_file,O_RDWR)) < 0) {
        build_error(msg_path,"GTMESSAG.CTL",FALSE);
        return;
    }
    if ((out_fileh = createfile(out_file)) < 0) {
	build_error(msg_path,"MESSAGE.CTL",TRUE);
	return;
    }
    fpos = 0L;
    flen = filelength(inp_fileh);
    while (fpos < flen) {
        seekfile(inp_fileh,fpos,SEEK_SET);
        readfile(inp_fileh,(char*) &old_msg_rec,sizeof(old_msg_rec));
        new_msg_rec.msg_deleted = old_msg_rec.msg_deleted;
        new_msg_rec.msg_number  = old_msg_rec.msg_number;
	if (!(old_msg_rec.msg_number % 25))
	    printf("Processing message number %d.\n",old_msg_rec.msg_number);
        pas_to_c(new_msg_rec.msg_sender,old_msg_rec.msg_sender,30);
        pas_to_c(new_msg_rec.msg_addressee,old_msg_rec.msg_addressee,30);
        pas_to_c(new_msg_rec.msg_topic,old_msg_rec.msg_topic,30);
        pas_to_c(new_msg_rec.msg_date,old_msg_rec.msg_date,8);
        new_msg_rec.msg_dest_net = old_msg_rec.msg_dest_net;
        if (old_msg_rec.msg_time[0] > 5)
	    old_msg_rec.msg_time[0] -= 3;
        pas_to_c(new_msg_rec.msg_time,old_msg_rec.msg_time,5);
	new_msg_rec.msg_weekday =
	  new_msg_rec.msg_filler =
	   new_msg_rec.msg_flags = 0;
	new_msg_rec.msg_dest_node = old_msg_rec.msg_dest_node;
	new_msg_rec.msg_perm_priv = old_msg_rec.msg_perm_priv;
	new_msg_rec.msg_received  = old_msg_rec.msg_received;
	new_msg_rec.msg_reply_no[0] = old_msg_rec.msg_reply_no[0];
	new_msg_rec.msg_reply_no[1] = old_msg_rec.msg_reply_no[1];
	new_msg_rec.msg_reply_no[2] = old_msg_rec.msg_reply_no[2];
	new_msg_rec.msg_orig_no     = old_msg_rec.msg_orig_no;
	writefile(out_fileh,(char *) &new_msg_rec,sizeof(new_msg_rec));
	fpos += (LONGINTEGER) sizeof(old_msg_rec);
    }
    _close(inp_fileh);
    closefile(out_fileh,out_file);
}

int import_user_msg(char *msg_path)
{
    LONGINTEGER fpos, flen;
    int inp_fileh, recno, res;
    char inp_file[128];
    DRAM *mfcb;
    DRAM *ufcb;
    USER_MSG_RECORD *mp;
    USER_RECORD *up;

    res = 0;
    printf("\nImporting: %sGTMAIL.CTL -> %sUSER_MSG.CTL\n\n",msg_path,msg_path);
    sprintf(inp_file,"%sGTMAIL.CTL",msg_path);
    if ((inp_fileh = _open(inp_file,O_RDWR)) < 0) {
	build_error(msg_path,"GTMAIL.CTL",FALSE);
	return(1);
    }
    mfcb = allocate_fcb();
    mp = mfcb->user_msg_rec;
    mfcb->dat_recsize = sizeof(USER_MSG_RECORD);
    mfcb->dat_keypos = 5;
    mfcb->dat_keytype = 1;
    strcpy(mfcb->dram_path,msg_path);
    dram_slasher(mfcb);
    strcpy(mfcb->dram_fname,"USER_MSG");
    if (dram(CREATE,mfcb)) {
	printf("\nERROR: Cannot create DRAM index and data file: %Fs%s",mfcb->dram_path,"USER_MSG");
	printf("\n       This can be caused by multiple entries in the GTMDIR.BBS file for the");
	printf("\n       same message base, or by files left from a previous conversion attempt.");
      printf("\n\n       If multiple attempts at import are made, you should erase all of the");
	printf("\n       USER.* and USER_MSG.* partially created by previous attempts.\n\n");
	sleep(5);
	res = 1;
	goto IMex;
    }
    ufcb = allocate_fcb();
    up = ufcb->user_rec;
    ufcb->dat_recsize = sizeof(USER_RECORD);
    ufcb->dat_keypos = 1;
    ufcb->dat_keytype = 0;
    strcpy(ufcb->dram_path,lan_path);
    dram_slasher(ufcb);
    strcpy(ufcb->dram_fname,"USER");
    if (dram(OPEN,ufcb)) {
	printf("\nERROR: Cannot open DRAM index and data file: %Fs%s\n",ufcb->dram_path,"USER");
	sleep(5);
	res = 1;
	goto IMex;
    }
    flen = filelength(inp_fileh);
    fpos = (LONGINTEGER) sizeof(old_user_rec);
    recno = 0;
    while (fpos < flen) {
	recno++;
	seekfile(inp_fileh,fpos,SEEK_SET);
	readfile(inp_fileh,(char*) &old_user_rec,sizeof(old_user_rec));
	pas_to_c(ufcb->string_key,old_user_rec.old_user_name,30);
	proper(ufcb->string_key);
	if (! dram(READ,ufcb)) {
	    mp->user_msg_deleted = 0;
	    mp->user_msg_prior_read = old_user_rec.old_user_msg_number;
	    mp->user_msg_highest_scan = old_user_rec.old_user_msg_number;
	    mp->user_msg_banned = old_user_rec.old_user_banned;
	    mp->user_msg_caller_no = up->user_caller_no;
	    mp->user_msg_hash_code = up->user_hash_code;
	    mp->user_msg_marked[0] =
	      mp->user_msg_marked[1] = 0;
	    if (!(recno % 25))
		printf("%5d.  %-32Fs%-32Fs\n",recno,up->user_name,up->user_city_state_zip);
	    strcpy(mfcb->string_key,up->user_name);
	    mfcb->binary_key = up->user_caller_no;
	    root = tree(root,up->user_caller_no,up->user_hash_code);
	    dram(APPEND,mfcb);
	}
	fpos += (LONGINTEGER) sizeof(old_user_rec);
    }
    dram(CLOSE,ufcb);
    dram(CLOSE,mfcb);
IMex:
    _close(inp_fileh);
    release_fcb(ufcb);
    ufcb=NULL;
    release_fcb(mfcb);
    mfcb=NULL;
    return(res);
}
**********/

int strip_nl(char *s,int imax)
{
    int j, lmax;

    lmax = imax - 1;
    j = 0;
    while ((s[j]) && (s[j] != '\n') && (s[j] != '\r') && (j < lmax))
	j++;
    s[j] = 0;
    return(j);
}

void scan_msg_bases(int typ)
{
    int j, rebuild_board_joins;
    char gtmdir[128], msg_path[128], wrk[262], group_name[128];
    char previous_msg_path[128], inp[128];
    FILE *fd;

    rebuild_board_joins = 0;
    if (typ == 3) {
	printf("\nDo you wish to rebuild the Board Join files?  [y/N] ");
	up_gets(inp);
	if (inp[0] == 'Y')
	    rebuild_board_joins = 1;
    }
    root = NULL;
    group_name[0] = 0;
    sprintf(gtmdir,"%sGTMDIR.BBS",gtpath);
    if ((fd = fopen(gtmdir,"rt")) == NULL) {
	sprintf(gtmdir,"%sGTMDIR.BBS",bbs_path);
	if ((fd = fopen(gtmdir,"rt")) == NULL) {
	    printf("\nCannot find the %s file.\n",gtmdir);
	    sleep(5);
	    return;
	}
    }
    clrscr();
    previous_msg_path[0] = 0;
    while (! feof(fd)) {
	if (fgets(wrk,260,fd) == NULL)
	    goto ScanExit;
	if ((strip_nl(wrk,260)) > 5) {
	    if (wrk[0] == '.') {
		if ((typ == 0) || (rebuild_board_joins)) {
		    if (root != NULL) {
			create_board_join(group_name);
			tree_erase(root);
		    }
		    root = NULL;
		}
		while ((wrk[0] != ' ') && (wrk[0]))
		    delete(wrk,1,1);
		while (wrk[0] == ' ')
		    delete(wrk,1,1);
		if ((j = pos(" ",wrk)))
		    wrk[j] = 0;
		wrk[79] = 0;
		strcpy(group_name,wrk);
		strupr(group_name);
		if ((typ == 3)&&(!rebuild_board_joins))
		    clean_up_board_joins(group_name);
	    }
	    else {
		if (wrk[0] > ' ') {
		    while ((wrk[0] != ' ') && (wrk[0]))
			delete(wrk,1,1);
		    while (wrk[0] == ' ')
			delete(wrk,1,1);
		    if ((j = pos(" ",wrk)))
			wrk[j] = 0;
		    if ((j = pos(",",wrk)))
			wrk[j] = 0;
		    wrk[79] = 0;
		    strcpy(msg_path,wrk);
		    process_pathname(msg_path);
		    if (! strcmp(previous_msg_path,msg_path))
			continue;
		    strcpy(previous_msg_path,msg_path);
		    switch (typ) {
//		    case 0:
//			if ((import_user_msg(msg_path)) == 0)
//			    import_msg(msg_path);
//			break;
		    case 1:
			delete_messages(msg_path);
			break;
		    case 2:
			renumber_messages(msg_path);
			break;
		    case 3:
			clean_up_user_msg_file(msg_path,rebuild_board_joins);
			break;
		    }
		}
	    }
	}
    }
ScanExit:
    if ((typ == 0) || (rebuild_board_joins)) {
	if (root != NULL) {
	    create_board_join(group_name);
	    tree_erase(root);
	}
	root = NULL;
    }
    fclose(fd);
}

void up_gets(char *s)
{
    gets(s);
    strupr(s);
}

void build_ctl(void)
{
    char wrk[128];

    printf("\nDo you wish to import the user control file? ");
    up_gets(wrk);
    if (wrk[0] == 'Y')
	build_user_ctl();
//  printf("\nDo you wish to import the message control files? ");
//  up_gets(wrk);
//  if (wrk[0] == 'Y')
//      scan_msg_bases(0);
}

void insert(char *addstring,char *newstring,int index)
{
    char temp[512];
    int k;

    temp[0] = 0;
    if ((! newstring[0]) || (index > strlen(newstring)))
	;
    else  {
        k = index - 1;
        copy_p(temp,(newstring + k),510);
        newstring[k] = 0;
    }
    strcat(newstring,addstring);
    strcat(newstring,temp);
}

void delete(char *destin,int start,int size)
{
    int j, m, k;

    if (k = strlen(destin)) {
        j = start - 1;
	destin[j] = 0;
        m = j + size;
	if (m < k)
            strcpy(&destin[j],&destin[m]);
    }
}

char *trim(char *st)
{
    int i;

    i = 0;
    while (st[i] <= ' ')
       i++;
    if (i)
	delete(st,1,i);
    i = strlen(st);
    do {
       st[i--] = 0;
    } while ((i >= 0) && (st[i] <= ' '));
    return(st);
}

int pos(char *searchtag,char *fulltag)
{
    int i, j, lensrch;

    if (lensrch = strlen(searchtag)) {
	j = strlen(fulltag) - lensrch + 1;
	for (i = 0; i < j; i++) {
	    if (! strncmp(searchtag,(fulltag + i),lensrch))
		return(i);
        }
	return(-1);
    }
    return(0);
}

void copy_p(char *ds,char *ss,int k)
{
    int i, j;

    i = 0;
    j = k - 1;
    do {
	if (! (ds[i] = ss[i]))
            return;
    } while (++i < j);
    ds[j] = 0;
}

void proper(char *s)
{
    int i, j, k, m;

    trim(s);
    if (!s[0])
	return;
    for (i = 0; s[i]; i++) {
	if ((s[i]<32) || (s[i]==';') || (s[i]=='%'))
	    s[i] = ' ';
    }
    strupr(s);
    i = 0;
    while (s[++i]) {
	if ((s[i] >= 'A') && (s[i] <= 'Z')) {
	    if (s[i] == 'D') {
		j = i - 1;
		k = j - 1;
		m = k - 1;
		if (m >= 0) {
		    if ((s[m]=='M') && (s[k]=='a') && (s[j]=='c'))
			goto ProperLoop;
		}
	    }
	    s[i] = _tolower(s[i]);
	    goto McCheck;
	}
	switch (s[i]) {
	case ',':
	    insert(" ",s,(i+2));
	    break;
	case '-':
	case '_':
	    goto UpperMc;
	case '.':
	    j = i - 1;
	    k = j - 1;
	    if (k >= 0) {
		k = toupper(s[k]);
		if ((k >= 'A') && (k <= 'Z'))
		    break;
	    }
	    s[j] = toupper(s[j]);
	    break;
	case ' ':
	case 39:
	    j = i + 1;
	    while (s[j] == ' ')
		delete(s,(j+1),1);
	    k = strlen(s);
	    if (j < k) {
		s[j] = toupper(s[j]);
		i = j;
	    }
	    break;
	default:
McCheck:
	    if (s[i] == 'c') {
		j = i - 1;
		if (j >= 0) {
		    if (s[j] == 'M')
			goto UpperMc;
		}
	    }
	}
	goto ProperLoop;
UpperMc:
	i++;
	s[i] = toupper(s[i]);
ProperLoop:
	;
    }
}

char *gttime(void)
{
    static char function[16];
    union REGS regs;

    regs.x.ax = 0x2c00;
    intdos(&regs,&regs);
    strcpy(function,build_time(regs.h.ch,regs.h.cl));
    function[5] = 0;
    return(function);
}

char *build_date(int m,int d,int y)
{
    static char date_buffer[16];

    if ((y > 15) && (y < 300))
        y += 1900;
    if (y < 1000) {
        y %= 100;
        y += 2000;
    }
    sprintf(date_buffer,"%2d-%02d-%04d",m,d,y);
    return(date_buffer);
}

char *calcdate(INTEGER dt)
{
    long gmt;
    struct tm dos_tm;
    static char ws[32];

    if (!dt)
	return("");
    gmt = GMT( ((((long)dt)-25569L+29221L)*86400L) );
    dos_tm = LCT(gmt);
    if (dos_tm.tm_mday > 31) {
        dos_tm.tm_mday -= 31;
        dos_tm.tm_mon++;
    }
    if (dos_tm.tm_mon > 11) {
        dos_tm.tm_mon -= 11;
        dos_tm.tm_year++;
    }
    strcpy(ws,build_date2000((dos_tm.tm_mon+1),dos_tm.tm_mday,dos_tm.tm_year));
    return(ws);
}

char *build_date2000(int m,int d,int y)
{
    static char date_buffer[16];

    if ((y > 15) && (y < 300))
        y += 1900;
    if (y < 1000) {
        y %= 100;
        y += 2000;
    }
    sprintf(date_buffer,"%04d%02d%02d",y,m,d);
    return(date_buffer);
}

char *date2000(void)
{
    union REGS regs;

    regs.x.ax = 0x2a00;
    intdos(&regs,&regs);
    return(build_date2000(regs.h.dh,regs.h.dl,regs.x.cx));
}

char *date(void)
{
    union REGS regs;

    regs.x.ax = 0x2a00;
    intdos(&regs,&regs);
    return(build_date(regs.h.dh,regs.h.dl,regs.x.cx));
}

long integer_input(char *p)
{
    char input_string[128];
    long result;

    printf("%s",p);
    gets(input_string);
    trim(input_string);
    result = atol(input_string);
    return(result);
}

INTEGER binary_input(char *p)
{
    char input_string[128];
    char *endptr;
    long result;

    printf("%s",p);
    gets(input_string);
    trim(input_string);
    result = strtol(input_string,&endptr,2);
    if ((result < 0L)||(result > 0x0000FFFFL))
        result = 0;
    return(((INTEGER) result));
}

char bool_input(char *p)
{
    char input_string[128];

    printf("%s",p);
    up_gets(input_string);
    trim(input_string);
    if ((input_string[0] == 'T') || (input_string[0] == 'Y'))
	return(1);
    return(0);
}

char *bool_print(char bool)
{
    if (bool)
	return("TRUE");
    return("FALSE");
}

char *tf_print(char bool)
{
    if (bool == 'T')
        return("TRUE");
    return("FALSE");
}

char char_input(char *p)
{
    char input_string[128];

    printf("%s",p);
    gets(input_string);
    trim(input_string);
    return(input_string[0]);
}

void str_input(char *d,char *p,int n)
{
    char input_string[512];

    printf("%s",p);
    gets(input_string);
    input_string[n] = 0;
    strcpy(d,input_string);
}

long extract_number(char *s,int *p)
{
    long result;
    int j, ch;

    j = (*p);
    result = 0;
    while (((ch = s[j]) < '0') || (ch > '9')) {
	if (!ch) {
            result = 0x7FFFFFFFL;
	    goto ExtractExit;
        }
	j++;
    }
    while (((ch = s[j]) >= '0') && (ch <= '9')) {
	result = (result * 10) + ch - '0';
	j++;
    }
    *p = j;
ExtractExit:
    return(result);
}

void date_input(char *dest,char *p)
{
    char input_string[128];
    int m, d, y, i;

    printf("%s",p);
    gets(input_string);
    if (input_string[0]==' ') {
	if ((input_string[1]==0)||(input_string[1]==' ')) {
	    dest[0] = ' ';
	    dest[1] = 0;
	    return;
	}
    }
    trim(input_string);
    input_string[10] = 0;
    i = 0;
    m = (int) extract_number(input_string,&i);
    if ((m > 0) && (m < 13)) {
	d = (int) extract_number(input_string,&i);
	if ((d > 0) && (d < 32)) {
	    y = (int) extract_number(input_string,&i);
	    if ((y >= 0) && (y < 3000))
		strcpy(input_string,build_date(m,d,y));
	}
    }
    input_string[10] = 0;
    strcpy(dest,input_string);
}

void add_user(void)
{
    LONGINTEGER caller_no;
    char cname[128], dwrk[128], mailbox_work[128];
    int st;
    DRAM *fcb;
    USER_RECORD *p;
    IDX_RECORD *xp;

    fcb = allocate_fcb();
    p  = fcb->user_rec;
    xp = fcb->idx_rec;
    fcb->dat_recsize = sizeof(USER_RECORD);
    fcb->dat_keypos = 1;
    fcb->dat_keytype = 0;
    strcpy(fcb->dram_path,lan_path);
    dram_slasher(fcb);
    strcpy(fcb->dram_fname,"_USER");
    if (dram(OPEN,fcb)) {
	import_error("_USER",lan_path);
	return;
    }
    seekfile(fcb->dat_handle,0L,SEEK_SET);
    readfile(fcb->dat_handle,(char*) p,sizeof(USER_RECORD));
    caller_no = p->user_caller_no;
    clrscr();
    printf("Add new user records:\n");
    do {
	printf("\nEnter new caller's name : ");
	gets(cname);
	if (! cname[0])
	    goto Loop;
	strcpy(fcb->string_key,cname);
	if (! dram(READ,fcb)) {
	    clrscr();
	    printf("Already registered!\n\n");
	    printf("Record Number ..... %u\n",xp->hash_ptr);
	    printf("Caller Name ....... %Fs\n",p->user_name);
            printf("Street Address .... %Fs\n",p->user_street_addr);
	    printf("City & State ...... %Fs\n",p->user_city_state_zip);
	    printf("Phone Number ...... %Fs\n",p->nf_phone);
            printf("Password .......... %Fs\n",p->user_password);
            printf("Access Level ...... %c\n",(int) p->nf_privel);
            printf("First -Date ....... %s\n",fmt_date2000(p->nf_first_date));
	    printf("First -Time ....... %Fs\n",p->user_first_time);
            printf("No. of Calls ...... %ld\n",p->user_total_calls);
            printf("Last -Date ........ %s\n",fmt_date2000(p->nf_last_date));
            printf("Last -Time ........ %Fs\n",p->user_last_time);
            printf("Netmail Credits ... %ld\n",p->user_netmail_credits);
            printf("Netmail Charges ... %ld\n",p->user_netmail_charges);
	    printf("Deleted Flag ...... %s\n",bool_print(p->user_deleted));
	    printf("Banned Flag ....... %s\n",bool_print(p->user_banned));
	    printf("Expire Date ....... %s\n",fmt_date2000(p->nf_expire_date));
	    goto Loop;
	}
        memset(p,0,sizeof(USER_RECORD));
        p->user_deleted = 0;
        strcpy(p->user_name,cname);
        proper(p->user_name);
	printf(                          "\nCaller Name ............ %Fs\n",p->user_name);
        str_input(p->user_street_addr,   "Street Address ......... ",30);
        proper(p->user_street_addr);
        str_input(p->user_city_state_zip,"City & State ........... ",30);
	proper(p->user_city_state_zip);
        postal_code_adj(p->user_city_state_zip);
        str_input(p->nf_phone,           "Phone Number ........... ",20);
        str_input(p->user_password,      "Password ............... ",20);
	strupr(p->user_password);
        p->nf_privel = char_input(       "Access Level ........... ");
        strcpy(p->nf_last_date,date2000());
	strcpy(p->user_last_time,gttime());
	strcpy(p->nf_first_date,p->nf_last_date);
	strcpy(p->user_first_time,p->user_last_time);
        p->user_netmail_credits = integer_input("Netmail Credits ........ ");
	p->user_banned            =  bool_input("Banned Flag ............ ");
	dwrk[0] = 0;
	date_input( dwrk,           "Expire Date ............ ");
        cvt_to_date2000(p->nf_expire_date,dwrk);
        p->user_expired_privel = char_input(     "Expired Access Level ... ");
	p->user_protocol = toupper(char_input(  "Transfer Protocol ...... "));
	if (p->user_protocol == 0)
	    p->user_protocol = ' ';
        p->user_screen_lgth = (INTEGER) integer_input(    "Screen Length .......... ");
	if ((p->user_screen_lgth < 1) || (p->user_screen_lgth > 999))
	    p->user_screen_lgth = 24;
	dwrk[0] = 0;
	date_input( dwrk,           "Birth Date ............. ");
        cvt_to_date2000(p->user_birth_date,dwrk);
        if (p->user_birth_date[0])
	    p->user_birth_date_verified = bool_input("Birth Date Verified? ... ");
        p->user_msgs_bitmask = binary_input("Message Base Bit Mask .. ");
        p->user_files_bitmask= binary_input("File Area Bit Mask ..... ");
ChooseMailbox:
        str_input(mailbox_work,"Mailbox Name ........... ",8);
        strupr(mailbox_work);
        st = is_legal_mailbox_name(p->user_name,mailbox_work,0,NULL,caller_no+1);
        if (st) {
            printf("\nPlease choose a different name... that one is in use!\n\n");
            goto ChooseMailbox;
        }
        if ((!mailbox_work[0])||(mailbox_work[0]==' ')) {
            mailbox_work[0] = 0xFF;
            mailbox_work[1] = 0;
        }
        strcpy(p->user_mailbox_name,mailbox_work);

        str_input(p->user_msgs_handle,"Handle For Messages .... ",30);

	p->user_caller_no = (++caller_no);
	strcpy(fcb->string_key,p->user_name);
	fcb->binary_key = p->user_caller_no;
	dram(ADD,fcb);
        seekfile(fcb->dat_handle,0L,SEEK_SET);
        readfile(fcb->dat_handle,(char*) p,sizeof(USER_RECORD));
        p->user_caller_no = caller_no;
        seekfile(fcb->dat_handle,0L,SEEK_SET);
        writefile(fcb->dat_handle,(char *) p,sizeof(USER_RECORD));
Loop:
        ;
    } while (cname[0]);
    dram(CLOSE,fcb);
    release_fcb(fcb);
    fcb = NULL;
}

void integer_ed(char *msk,int item,LONGINTEGER *i,int il)
{
    int k;
    long j;
    char s[128];
    char sp[60];

    memset(sp,' ',50);
    sp[50] = 0;
    k = (strlen(msk) - 5);
    if (item < 10)
        k--;
    sp[k] = 0;
    printf(msk,item,*i);
    j=(*i);
    ltoa(j,s,10);
    str_input(s,sp,il);
    if (s[0])
	*i = atol(s);
}

void string_ed(char *msk,int item,char *is,int il)
{
    int k;
    char s[128], sp[128];

    memset(sp,' ',50);
    sp[50] = 0;
    k = (strlen(msk) - 4);
    if (item >= 0) {
        if (item < 10)
            k--;
        sp[k] = 0;
        printf(msk,item,is);
    }
    else {
        sp[++k] = 0;
        printf(msk,is);
    }
    strcpy(s,is);
    str_input(s,sp,il);
    if (s[0]) {
	s[il] = 0;
	strcpy(is,s);
    }
}

char *edit_user(int item,DRAM *fcb)
{
    char s[128];
    char mailbox_work[128];
    int st, rename_flag, ch;
    USER_RECORD *p;
    IDX_RECORD *xp;
    LONGINTEGER lwork;

    if (!item)
	return("");
    p  = fcb->user_rec;
    xp = fcb->idx_rec;
    switch (item) {
    case 1:
        string_ed("%d. Street Address .. %Fs\n",item,p->user_street_addr,30);
        proper(p->user_street_addr);
        break;
    case 2:
	string_ed("%d. City & State .. %Fs\n",item,p->user_city_state_zip,30);
	process_city_state(fcb);
	break;
    case 3:
	string_ed("%d. Phone Number .. %Fs\n",item,p->nf_phone,20);
	break;
    case 4:
	string_ed("%d. Password .. %Fs\n",item,p->user_password,20);
	strupr(p->user_password);
	break;
    case 5:
	printf("%d. Access Level .. %c\n",item,(int) p->nf_privel);
	s[0] = (char) p->nf_privel;
	s[1] = 0;
	str_input(s,"                   ",1);
	if (s[0])
	    p->nf_privel = s[0];
	break;
    case 6:
        strcpy(s,fmt_date2000(p->nf_first_date));
	string_ed("%d. First Call -Date .. %Fs\n",item,s,10);
        if (is_blank_line(s))
            p->nf_first_date[0] = 0;
        else
            cvt_to_date2000(p->nf_first_date,s);
	break;
    case 7:
	string_ed("%d. First Call -Time .. %Fs\n",item,p->user_first_time,5);
	break;
    case 8:
	integer_ed("%d. No. of Calls .. %Fld\n",item,&(p->user_total_calls),7);
	break;
    case 9:
        strcpy(s,fmt_date2000(p->nf_last_date));
	string_ed("%d. Last Call -Date .. %Fs\n",item,s,10);
        if (is_blank_line(s))
            p->nf_last_date[0] = 0;
        else
            cvt_to_date2000(p->nf_last_date,s);
	break;
    case 10:
	string_ed("%d. Last Call -Time .. %Fs\n",item,p->user_last_time,5);
	break;
    case 11:
	integer_ed("%d. Netmail Credits .. %Fld\n",item,&(p->user_netmail_credits),7);
	break;
    case 12:
	integer_ed("%d. Netmail Charges .. %Fld\n",item,&(p->user_netmail_charges),7);
	break;
    case 13:
	if (p->user_banned)
	    return("ERROR: Cannot change the \"Deleted Flag\".  This caller is banned!");
	else {
	    strcpy(s,bool_print(p->user_deleted));
	    printf("%d. Deleted Flag .. %s\n",item,s);
	    str_input(s,"                    ",5);
	    if (s[0]) {
		strupr(s);
		p->user_deleted = 0;
		if ((s[0] == 'Y') || (s[0] == 'T')) {
                    erase_mailbox(p,p->user_caller_no);
		    p->user_deleted = 1;
		}
		seekfile(fcb->idx_handle,fcb->idxfpos,SEEK_SET);
		readfile(fcb->idx_handle,(char*) xp,sizeof(IDX_RECORD));
		xp->hash_del_flg = p->user_deleted;
		seekfile(fcb->idx_handle,fcb->idxfpos,SEEK_SET);
		writefile(fcb->idx_handle,(char *) xp,sizeof(IDX_RECORD));
	    }
	}
	break;
    case 14:
	if (p->user_deleted)
	    return("ERROR: Cannot change the \"Banned Flag\".  This caller is deleted!");
	else {
	    strcpy(s,bool_print(p->user_banned));
	    printf("%d. Banned Flag .. %s\n",item,s);
	    str_input(s,"                   ",5);
	    if (s[0]) {
		strupr(s);
		p->user_banned = 0;
		if ((s[0] == 'Y') || (s[0] == 'T')) {
		    p->user_banned = 1;
		}
	    }
	}
	break;
    case 15:
	s[0] = p->user_protocol;
	s[1] = 0;
	printf("%d. Transfer Protocol .. %s\n",item,s);
	str_input(s,"                         ",1);
	if (s[0]) {
	    p->user_protocol = toupper(s[0]);
	}
	break;
    case 16:
        lwork = p->user_screen_lgth;
	integer_ed("%d. Screen Length .. %Fld\n",item,(LONGINTEGER *) &lwork,3);
        p->user_screen_lgth = (INTEGER) lwork;
	break;
    case 17:
	strcpy(s,bool_print(p->user_expert));
	printf("%d. Expert Mode .. %s\n",item,s);
	str_input(s,"                   ",5);
	if (s[0]) {
	    strupr(s);
	    p->user_expert = 0;
	    if ((s[0] == 'Y') || (s[0] == 'T')) {
		p->user_expert = 1;
	    }
	}
	break;
    case 18:
        strcpy(s,p->user_mailbox_name);
        rename_flag = 1;
        ch = s[0] & 0x00FF;
        if ((!ch)||(ch==' ')||(ch==0x00FF))
            rename_flag = 0;
        strcpy(mailbox_work,p->user_mailbox_name);
ChooseMailbox:
	string_ed("%d. Mailbox Name .. %Fs\n",item,mailbox_work,8);
        strupr(mailbox_work);
        if (strcmp(s,mailbox_work)) {
            st = is_legal_mailbox_name(p->user_name,mailbox_work,rename_flag,s,p->user_caller_no);
            if (st) {
                printf("\nPlease choose a different name... that one is in use!\n\n");
                goto ChooseMailbox;
            }
            ch = mailbox_work[0] & 0x00FF;
            if ((!ch)||(ch==' ')) {
                erase_mailbox(p,p->user_caller_no);
                mailbox_work[0] = 0xFF;
                mailbox_work[1] = 0;
            }
            strcpy(p->user_mailbox_name,mailbox_work);
        }
	break;
    case 19:
	integer_ed("%d. Upload K .. %Fld\n",item,&(p->user_total_upload_k),7);
	break;
    case 20:
        lwork = p->user_total_upload_files;
        integer_ed("%d. Files Uploaded .. %Fld\n",item,&lwork,7);
        p->user_total_upload_files = (INTEGER) lwork;
        break;
    case 21:
	integer_ed("%d. Download K .. %Fld\n",item,&(p->user_total_dnload_k),7);
	break;
    case 22:
        lwork = p->user_total_dnload_files;
        integer_ed("%d. Files Downloaded .. %Fld\n",item,&lwork,5);
        p->user_total_dnload_files = (INTEGER) lwork;
	break;
    case 23:
	strcpy(s,bool_print(p->user_more));
	printf("%d. Continuous Output .. %s\n",item,s);
	str_input(s,"                         ",5);
	if (s[0]) {
	    strupr(s);
	    p->user_more = 0;
	    if ((s[0] == 'Y') || (s[0] == 'T')) {
		p->user_more = 1;
	    }
	}
	break;
    case 24:
	integer_ed("%d. Caller Number .. %Fld\n",item,&(p->user_caller_no),7);
	break;
    case 25:
	lwork = p->user_day_calls;
	integer_ed("%d. Calls Today .. %Fld\n",item,(LONGINTEGER *) &lwork,2);
	p->user_day_calls = (INTEGER) lwork;
	break;
    case 26:
        strcpy(s,fmt_date2000(p->nf_expire_date));
	string_ed("%d. Expire Date .. %Fs\n",item,s,10);
        if (is_blank_line(s))
            p->nf_expire_date[0] = 0;
        else
            cvt_to_date2000(p->nf_expire_date,s);
	break;
    case 27:
	printf("%d. Expiry Access Level .. %c\n",item,(int) p->user_expired_privel);
	s[0] = (char) p->user_expired_privel;
	s[1] = 0;
	str_input(s,"                           ",1);
	if (s[0])
	    p->user_expired_privel = s[0];
	break;
    case 28:
	integer_ed("%d. Download K Today .. %Fld\n",item,&(p->user_day_dnload_k),7);
	break;
    case 29:
	integer_ed("%d. Time Bank .. %Fld\n",
            item,(LONGINTEGER *) &(p->user_total_time_bank),7);
	break;
    case 30:
	string_ed("%d. CB Handle .. %Fs\n",item,p->user_cb_handle,9);
	break;
    case 31:
        strcpy(s,fmt_date2000(p->user_birth_date));
	string_ed("%d. Birthday .. %Fs\n",item,s,10);
        if (is_blank_line(s))
            p->user_birth_date[0] = 0;
        else
            cvt_to_date2000(p->user_birth_date,s);
	break;
    case 32:
	strcpy(s,bool_print(p->user_birth_date_verified));
	printf("%d. Birthday Verified .. %s\n",item,s);
	str_input(s,"                         ",5);
	if (s[0]) {
	    strupr(s);
	    p->user_birth_date_verified = 0;
	    if ((s[0] == 'Y') || (s[0] == 'T')) {
		p->user_birth_date_verified = 1;
	    }
	}
	break;
    case 33:
	strcpy(s,tf_print(p->user_clear_screen));
	printf("%d. Send Clear Screen .. %s\n",item,s);
	str_input(s,"                         ",5);
	if (s[0]) {
	    strupr(s);
	    p->user_clear_screen = 'T';
	    if ((s[0] == 'N') || (s[0] == 'F')) {
		p->user_clear_screen = 'F';
	    }
	}
	break;
    }
    return("");
}

void display_record(USER_RECORD *up,unsigned rp,char *edit_error)
{
    clrscr();
    if (edit_error[0])
        printf("%s\n\n",edit_error);
    printf("    Caller Name .... %-32Fs    Record# %u\n",up->user_name,rp);
    printf(" 1. Street Address . %Fs\n",up->user_street_addr);
    printf(" 2. City & State ... %Fs\n",up->user_city_state_zip);
    printf(" 3. Phone Number ... %-20Fs 19. Upload KB ......... %lu\n",up->nf_phone,up->user_total_upload_k);
    printf(" 4. Password ....... %-20Fs 20. Files Uploaded .... %u\n",up->user_password,up->user_total_upload_files);
    printf(" 5. Access Level ... %-20c 21. Download KB ....... %lu\n",(int)up->nf_privel,up->user_total_dnload_k);
    printf(" 6. First -Date .... %-20s 22. Files Downloaded .. %u\n",fmt_date2000(up->nf_first_date),up->user_total_dnload_files);
    printf(" 7. First -Time .... %-20Fs 23. Continuous Output . %s\n",trim(up->user_first_time),bool_print(up->user_more));
    printf(" 8. No. of Calls ... %-20lu 24. Caller Number ..... %lu\n",up->user_total_calls,up->user_caller_no);
    printf(" 9. Last -Date ..... %-20s 25. Calls Today ....... %d\n",fmt_date2000(up->nf_last_date),up->user_day_calls);
    printf("10. Last -Time ..... %-20Fs 26. Expiry Date ....... %s\n",trim(up->user_last_time),fmt_date2000(up->nf_expire_date));
    printf("11. Netmail Credit . %-20lu 27.   ''  Access Level. %c\n",up->user_netmail_credits,up->user_expired_privel);
    printf("12. Netmail Charges. %-20lu 28. Download K Today .. %lu\n",up->user_netmail_charges,up->user_day_dnload_k);
    printf("13. Deleted Flag ... %-20s 29. Time Bank ......... %ld\n",bool_print(up->user_deleted),up->user_total_time_bank);
    printf("14. Banned Flag .... %-20s 30. CB Handle ......... %Fs\n",bool_print(up->user_banned),up->user_cb_handle);
    printf("15. Xfer Protocol .. %-20c 31. Birthday .......... %s\n",up->user_protocol,fmt_date2000(up->user_birth_date));
    printf("16. Screen Length .. %-20u 32. Birthday Verified . %s\n",up->user_screen_lgth,bool_print(up->user_birth_date_verified));
    printf("17. Expert Mode .... %-20s 33. Send Clear Screen . %s\n",bool_print(up->user_expert),tf_print(up->user_clear_screen));
    printf("18. Mailbox Name ... %-20s\n\n",up->user_mailbox_name);
}

int display_record_pt2(USER_RECORD *up,unsigned rp)
{
    int keypress;
/***
 Totals:  Calls: xxxxxx   Connect: xxxxxx    Peak: xxxxxx   Off-Peak: xxxxxx
***/

    clrscr();
    printf(" Caller Name ... %-32Fs         Record No: %u\n\n",up->user_name,rp);

    printf(" Totals:  Calls: %-6lu   Connect: %-6lu    Peak: %-6lu   Off-Peak: %lu\n",
        up->user_total_calls,
        up->user_total_connect_time,
        up->user_total_connect_time_peak,
        up->user_total_connect_time_offpeak);
    printf("          U/L K: %-6lu     D/L K: %-6lu MsgRead: %-6lu  MsgStored: %lu\n",
        up->user_total_upload_k,
        up->user_total_dnload_k,
        up->user_total_msgs_read,
        up->user_total_msgs_stored);
    printf("          Files: %-6u     Files: %-6u                  Time Bank: %ld\n",
        up->user_total_upload_files,
        up->user_total_dnload_files,
        up->user_total_time_bank);
    printf("\n Yearly:  Calls: %-6u   Connect: %-6lu    Peak: %-6lu   Off-Peak: %lu\n",
        up->user_year_calls,
        up->user_year_connect_time,
        up->user_year_connect_time_peak,
        up->user_year_connect_time_offpeak);
    printf("          U/L K: %-6lu     D/L K: %-6lu              Time Bank (+): %ld\n",
        up->user_year_upload_k,
        up->user_year_dnload_k,
        up->user_year_time_deposits);
    printf("          Files: %-6u     Files: %-6u              Time Bank (-): %ld\n",
        up->user_year_upload_files,
        up->user_year_dnload_files,
        up->user_year_time_withdrawals);
    printf("\nMonthly:  Calls: %-6u   Connect: %-6u    Peak: %-6u   Off-Peak: %u\n",
        up->user_month_calls,
        up->user_month_connect_time,
        up->user_month_connect_time_peak,
        up->user_month_connect_time_offpeak);
    printf("          U/L K: %-6lu     D/L K: %-6lu              Time Bank (+): %ld\n",
        up->user_month_upload_k,
        up->user_month_dnload_k,
        up->user_month_time_deposits);
    printf("          Files: %-6u     Files: %-6u              Time Bank (-): %ld\n",
        up->user_month_upload_files,
        up->user_month_dnload_files,
        up->user_month_time_withdrawals);
    printf("\n Weekly:  Calls: %-6u   Connect: %-6u    Peak: %-6u   Off-Peak: %u\n",
        up->user_week_calls,
        up->user_week_connect_time,
        up->user_week_connect_time_peak,
        up->user_week_connect_time_offpeak);
    printf("          U/L K: %-6lu     D/L K: %-6lu              Time Bank (+): %d\n",
        up->user_week_upload_k,
        up->user_week_dnload_k,
        up->user_week_time_deposits);
    printf("          Files: %-6u     Files: %-6u              Time Bank (-): %d\n",
        up->user_week_upload_files,
        up->user_week_dnload_files,
        up->user_week_time_withdrawals);
    printf("\n  Daily:  Calls: %-6u   Connect: %-6u    Peak: %-6u   Off-Peak: %u\n",
        up->user_day_calls,
        up->user_day_connect_time,
        up->user_day_connect_time_peak,
        up->user_day_connect_time_offpeak);
    printf("          U/L K: %-6lu     D/L K: %-6lu              Time Bank (+): %d\n",
        up->user_day_upload_k,
        up->user_day_dnload_k,
        up->user_day_time_deposits);
    printf("          Files: %-6u     Files: %-6u              Time Bank (-): %d\n",
        up->user_day_upload_files,
        up->user_day_dnload_files,
        up->user_day_time_withdrawals);
    printf("\nEnter: (R)eturn (F)rwd (B)ack (Q)uit: ");
    keypress = my_getkey(0);
    switch (toupper(keypress)) {
	case 'N':
	case '+':
	case '=':
        case 'F': return('F');
	case 'P':
	case '-':
	case '_':
        case 'B': return('B');
        case 'Q': return('Q');
    }
    return('R');
}

void find_user(int direct,char *msg_path)
{
    LONGINTEGER datflen;
    int action, edit_allowed, item, w, PartTwo, j;
    long go_to, max_fpos;
    char cname[128];
    char cmd[128];
    char *edit_error;
    int no_record;
    BOOLEAN msg_ban;
    DRAM *ufcb;
    DRAM *mfcb;
    USER_RECORD *up;
    IDX_RECORD *uxp;
    IDX_RECORD *mxp;
    USER_MSG_RECORD *mp;

    PartTwo = FALSE;
    ufcb = allocate_fcb();
    up  = ufcb->user_rec;
    uxp = ufcb->idx_rec;
    ufcb->dat_recsize = sizeof(USER_RECORD);
    ufcb->dat_keypos = 1;
    ufcb->dat_keytype = 0;
    strcpy(ufcb->dram_path,lan_path);
    dram_slasher(ufcb);
    strcpy(ufcb->dram_fname,"_USER");
    if (dram(OPEN,ufcb)) {
	import_error("_USER",lan_path);
	return;
    }
    mfcb = allocate_fcb();
    mp = mfcb->user_msg_rec;
    mxp = mfcb->idx_rec;
    mfcb->dat_recsize = sizeof(USER_MSG_RECORD);
    mfcb->dat_keypos = 5;
    mfcb->dat_keytype = 1;
    strcpy(mfcb->dram_path,msg_path);
    dram_slasher(mfcb);
    strcpy(mfcb->dram_fname,"USER_MSG");
    if (dram(OPEN,mfcb)) {
	import_error("USER_MSG",msg_path);
	return;
    }
    if (direct)
        goto DAccess;
Loop:
    printf("Enter caller's name : ");
    edit_allowed = 0;
    gets(cname);
    if (!cname[0])
	goto Lexit;
Locate1:
    edit_error = "";
Locate2:
    strcpy(ufcb->string_key,cname);
    if (!dram(READ,ufcb)) {
	strcpy(mfcb->string_key,up->user_name);
	mfcb->binary_key = up->user_caller_no;
	no_record = 0;
	if (dram(READ,mfcb)) {
	    memset(mp,0,sizeof(USER_MSG_RECORD));
	    no_record = 1;
	}
        if (PartTwo) {
            action = 'T';
            goto BeginOfSwitch;
        }
	display_record(up,uxp->hash_ptr,edit_error);
	if (no_record) {
	    printf("    No message base record on file for this caller.\n");
	}
	else {
	    printf("    Last Read %d   Last Scan %d   Msg Ban %s   Msg Caller# %lu\n",
	        mp->user_msg_prior_read,mp->user_msg_highest_scan,
	        bool_print(mp->user_msg_banned),mp->user_msg_caller_no);
	}
	printf("\n(1-33)Edit (M)sg Ban (T)otals ");
	edit_allowed = 1;
    }
    else {
        printf("\nNot found!\n\n");
        edit_allowed = 0;
    }
    printf("(L)ookup (F)rwd (B)ack (G)oto (Q)uit: ");
cBksp:
    cmd[0] = my_getkey(1);
    cmd[1] = 0;
    if (cmd[0]=='\x08')
	goto cBksp;
    strupr(cmd);
    action = cmd[0];
    item = 0;
    if ((action >= '1') && (action <= '9')) {
	w = 0;
	item = action - '0';
	action = 'E';
	if ((item > 0) && (item < 4)) {
	    cmd[1] = my_getkey(0);
	    cmd[2] = 0;
	    if (cmd[1]=='\x08')
		goto cBksp;
	    w = cmd[1];
	    if ((w >= '0') && (w <= '9')) {
		item = (item * 10) + w - '0';
	    }
	}
    }
    for (j=0; j<70; j++)
        printf("\b \b");
BeginOfSwitch:
    PartTwo = FALSE;
    switch (action) {
	case 'Q':
	    goto Lexit;
	case 'M':
	    if (edit_allowed) {
		msg_ban = 1;
		if (mp->user_msg_banned)
		    msg_ban = 0;
		mp->user_msg_banned = msg_ban;
		mfcb->datfpos = (((LONGINTEGER) mxp->hash_ptr) * ((LONGINTEGER) sizeof(USER_MSG_RECORD)));
		seekfile(mfcb->dat_handle,mfcb->datfpos,SEEK_SET);
		writefile(mfcb->dat_handle,(char *) mp,sizeof(USER_MSG_RECORD));
		goto Locate2;
	    }
	case 'E':
	    if (edit_allowed) {
		edit_error = edit_user(item,ufcb);
		ufcb->datfpos = (((LONGINTEGER) uxp->hash_ptr) * ((LONGINTEGER) sizeof(USER_RECORD)));
		seekfile(ufcb->dat_handle,ufcb->datfpos,SEEK_SET);
		writefile(ufcb->dat_handle,(char *) up,sizeof(USER_RECORD));
		goto Locate2;
	    }
	    break;
        case 'T':
            if (edit_allowed) {
                action = display_record_pt2(up,uxp->hash_ptr);
                if (action == 'F') {
                    PartTwo = TRUE;
                    goto NextRecord;
                }
                if (action == 'B') {
                    PartTwo = TRUE;
                    goto PriorRecord;
                }
                if (action == 'Q')
                    goto Lexit;
                goto Locate1;
            }
            break;
	case 'N':
	case 'F':
	case '+':
	case '=':
NextRecord:
	    uxp->hash_ptr++;
            ufcb->datfpos = (((LONGINTEGER) uxp->hash_ptr) * ((LONGINTEGER) sizeof(USER_RECORD)));
	    datflen = filelength(ufcb->dat_handle);
	    if (ufcb->datfpos >= datflen) {
		ufcb->datfpos = ((LONGINTEGER) sizeof(USER_RECORD));
	    }
	    seekfile(ufcb->dat_handle,ufcb->datfpos,SEEK_SET);
	    readfile(ufcb->dat_handle,(char*) up,sizeof(USER_RECORD));
	    strcpy(cname,up->user_name);
	    goto Locate1;
	case 'P':
	case 'B':
	case '-':
	case '_':
PriorRecord:
	    uxp->hash_ptr--;
            ufcb->datfpos = (((LONGINTEGER) uxp->hash_ptr) * ((LONGINTEGER) sizeof(USER_RECORD)));
	    datflen = filelength(ufcb->dat_handle);
	    max_fpos = (datflen - ((LONGINTEGER) sizeof(USER_RECORD)));
	    if ((ufcb->datfpos <= 0)||(ufcb->datfpos > max_fpos)) {
		ufcb->datfpos = max_fpos;
            }
	    seekfile(ufcb->dat_handle,ufcb->datfpos,SEEK_SET);
	    readfile(ufcb->dat_handle,(char*) up,sizeof(USER_RECORD));
	    strcpy(cname,up->user_name);
	    goto Locate1;
	case 'G':
DAccess:
	    go_to = integer_input("Enter record number : ");
            ufcb->datfpos = (((LONGINTEGER) go_to) * ((LONGINTEGER) sizeof(USER_RECORD)));
	    datflen = filelength(ufcb->dat_handle);
	    if ((ufcb->datfpos > 0) && (ufcb->datfpos < datflen)) {
		seekfile(ufcb->dat_handle,ufcb->datfpos,SEEK_SET);
		readfile(ufcb->dat_handle,(char*) up,sizeof(USER_RECORD));
		strcpy(cname,up->user_name);
		goto Locate1;
	    }
	    break;
	case 'L':
	    break;
	default:
	    break;
    }
    goto Loop;
Lexit:
    dram(CLOSE,mfcb);
    dram(CLOSE,ufcb);
    release_fcb(mfcb);
    mfcb=NULL;
    release_fcb(ufcb);
    ufcb=NULL;
}

void construct_mailbox_path(char *os,char *box,char *s,unsigned long nbr)
{
    unsigned long box_nbr;

    box_nbr = nbr / 300 + 1;
    sprintf(box,"%s%04ld\\",mailbox_dir,box_nbr);
    sprintf(os,"%s%s",box,s);
}

void make_mailbox(char *owner,char *s,unsigned long nbr)
{
    FILE *fp;
    char mailbox_path[128];
    char box_path[128];
    char cwd[128];

    getcwd(cwd,120);
    mak_dir(mailbox_dir);
    construct_mailbox_path(mailbox_path,box_path,s,nbr);
    mak_dir(box_path);
    mak_dir(mailbox_path);
    chg_dir(mailbox_path);
    if ((fp = fopen("OWNER.BOX","wt")) == NULL)
        return;
    fprintf(fp,"%s\n",owner);
    fclose(fp);
    mak_dir("GTMSGS");
    mak_dir("FILES");
    chg_dir(cwd);
}

int is_legal_mailbox_name(char *owner,char *ckstr,int rename_it,char *old_name,unsigned long nbr)
{
    FILE *fp;
    char old_pathname[128];
    char mailbox_path[128];
    char file_name[128];
    char box_path[128];
    char owner_name[128];
    int j, ch;

    if (is_blank_line(ckstr)) {
        ckstr[0] = 0;
        return(0);
    }
    if ((ckstr[0] & 0x00FF) == 0x00FF)
        return(0);
    strupr(ckstr);
    for (j=0; (ch = ckstr[j]); j++) {
        if ((ch<'0')||(ch>'9'))
            if ((ch<'A')||(ch>'Z'))
                ckstr[j] = '_';
    }
    construct_mailbox_path(mailbox_path,box_path,ckstr,nbr);
    if (!dexist(mailbox_path)) {
        if (rename_it) {
            construct_mailbox_path(old_pathname,box_path,old_name,nbr);
            rename(old_pathname,mailbox_path);
            return(0);
        }
MakeIt:
        if (rename_it)
            return(100);
        make_mailbox(owner,ckstr,nbr);
        return(0);
    }
    sprintf(file_name,"%s\\%s",mailbox_path,"OWNER.BOX");
    if ((fp = fopen(file_name,"rt")) == NULL)
        goto MakeIt;
    if ((fgets_p(owner_name,120,fp)) < 0)
        goto MakeIt;
    fclose(fp);
    if (stricmp(owner_name,owner))
        return(100);
    return(0);
}

void erase_mailbox(USER_RECORD *p,unsigned long nbr)
{
    int ch;
    char cwd[128];
    char box_path[128];
    char work_dir[128];
    char sub_dir1[128];
    char sub_dir2[128];

    ch = p->user_mailbox_name[0] & 0x00FF;
    if ((!ch)||(ch==' ')||(ch==0x00FF)) {
        return;
    }
    getcwd(cwd,120);
    construct_mailbox_path(work_dir,box_path,p->user_mailbox_name,nbr);
    if (chg_dir(work_dir)) {
        chg_dir(cwd);
        return;
    }
    sprintf(sub_dir1,"%s\\%s\\",work_dir,"GTMSGS");
    sprintf(sub_dir2,"%s\\%s\\",work_dir,"FILES");
//                                            printf("\n DIR = %s ",sub_dir1);
    if (!chg_dir(sub_dir1)) {
        FileDelete("","*.*");
    }
//                                            printf("\n DIR = %s ",sub_dir2);
    if (!chg_dir(sub_dir2)) {
        FileDelete("","*.*");
    }
//                                            printf("\n DIR = %s ",work_dir);
    if (!chg_dir(work_dir))
        FileDelete("","*.*");
//                                            gets(temp);
    rmdir("GTMSGS");
    rmdir("FILES");
    chg_dir(box_path);
    rmdir(p->user_mailbox_name);
    chg_dir(cwd);
    p->user_mailbox_name[0] = ' ';
}

void delete_user(void)
{
    char cname[128];
    DRAM *fcb;
    USER_RECORD *p;

    fcb = allocate_fcb();
    p  = fcb->user_rec;
    fcb->dat_recsize = sizeof(USER_RECORD);
    fcb->dat_keypos = 1;
    fcb->dat_keytype = 0;
    strcpy(fcb->dram_path,lan_path);
    dram_slasher(fcb);
    strcpy(fcb->dram_fname,"_USER");
    if (dram(OPEN,fcb)) {
	import_error("_USER",lan_path);
	return;
    }
    clrscr();
    printf("Delete user records:\n");
Loop:
    printf("\nEnter the caller's name to delete : ");
    gets(cname);
    if (!cname[0])
	goto Dex;
    strcpy(fcb->string_key,cname);
    if (dram(READ,fcb)) {
	printf("\nNot found!\n");
	goto Loop;
    }
    printf("\n");
    printf("Caller Name  : %Fs\n",p->user_name);
    printf("City & State : %Fs",p->user_city_state_zip);
    if (p->user_banned)
	printf("\n\nCannot delete.  This caller is banned!\n");
    else {
        erase_mailbox(p,p->user_caller_no);
	dram(DELETE,fcb);
        printf("\n\nDeleted!\n");
    }
    goto Loop;
Dex:
    dram(CLOSE,fcb);
    release_fcb(fcb);
    fcb=NULL;
}

void examine_lost(void)
{
    DRAM *fcb;
    char cns[128], work_str[128];
    unsigned cnum;
    LONGINTEGER snum;
    USER_RECORD *p;

    fcb = allocate_fcb();
    p  = fcb->user_rec;
    fcb->dat_recsize = sizeof(USER_RECORD);
    fcb->dat_keypos = 1;
    fcb->dat_keytype = 0;
    strcpy(fcb->dram_path,lan_path);
    dram_slasher(fcb);
    strcpy(fcb->dram_fname,"_USER");
    if (dram(OPEN,fcb)) {
	import_error("_USER",lan_path);
	return;
    }
    printf("\nEnter the record # of interest: ");
    gets(cns);
    if (cns[0]) {
	cnum=atoi(cns);
	snum=(((LONGINTEGER) cnum) * ((LONGINTEGER) sizeof(USER_RECORD)));
	seekfile(fcb->dat_handle,snum,SEEK_SET);
	readfile(fcb->dat_handle,(char*) p,sizeof(USER_RECORD));
	sprintf(work_str,"Record Offset : %ld",snum);
	display_record(p,cnum,work_str);
	pause_to_read(TRUE);
    }
    dram(CLOSE,fcb);
    release_fcb(fcb);
    fcb=NULL;
}

int flake_scan(char *inp)
{
    int j, c;

    for (j=0; (c = (inp[j] & 0x00FF)); j++) {
	if ((c==0x7B)||(c==0x7F)||(c==0xFB)||(c==0xAE)||(c==0xAF)||(c==0xDB)||(c==0xFE))
	    return(1);
    }
    return(0);
}

void clean_up_user_file(void)
{
    LONGINTEGER fpos, flen;
    int inp_fileh, remove_dels, trash_removal, bad_one;
    int date_purge, remove_expired;
    LONGINTEGER call_override;
    INTEGER curr_daynumber;
    int expire_limit, day_override, expire_daynumber, days_since_last_on;
    LONGINTEGER privel_override;
    LONGINTEGER count;
    char inp_file[128], inp[128], s[128];
    DRAM *fcb;
    USER_RECORD *p;

    clrscr();
    curr_daynumber = daynumber(date2000());
    printf("\nDo you wish to purge deleted records?   [y/N]  ");
    up_gets(inp);
    remove_dels = 0;
    if (inp[0] == 'Y')
	remove_dels = 1;
    printf("\nDo you wish to scan trashed records?    [y/N]  ");
    up_gets(inp);
    trash_removal = 0;
    if (inp[0] == 'Y')
	trash_removal = 1;
    printf("\nDo you wish to remove expired records?  [y/N]  ");
    up_gets(inp);
    remove_expired = 0;
    if (inp[0] == 'Y')
	remove_expired = 1;
    expire_limit = 30;
    if (remove_expired) {
	printf("\n    Max number of days since expiration     : ");
	gets(inp);
	if (inp[0])
	    expire_limit = atoi(inp);
    }
Oldies:
    printf("\nDo you wish to purge inactive records?  [y/N]  ");
    up_gets(inp);
    date_purge = 0;
    privel_override = 0;
    day_override = 32767;
    call_override = 0x7FFFFFFFL;
    if (inp[0] == 'Y') {
	date_purge = 1;
	printf("\n    Max number of days since last call      : ");
	gets(inp);
	if (inp[0]) {
	    if ((day_override = atoi(inp)) < 90) {
		printf("\nRemove users that have been inactive for %d days?? [y/N]  ",day_override);
		up_gets(inp);
		if (inp[0] != 'Y')
		    goto Oldies;
		printf("\n");
	    }
	}
	printf(  "    Access level to override removal        : ");
	gets(inp);
	if (inp[0] >= '0')
	    privel_override = inp[0];
	printf("    Number of calls to override removal     : ");
	gets(inp);
	if (inp[0])
	    call_override = atoi(inp);
	printf("\nAre you sure? [Y/n]  ");
	up_gets(inp);
	if (inp[0] == 'N')
	    goto Oldies;
	printf("\n");
    }
    backup_file(lan_path,"_USER","IDX","O_USER");
    backup_file(lan_path,"_USER","CTL","O_USER");
    printf(  "\nIf this process does not complete successfully, the _USER files can be");
    printf(  "\nrecovered by copying files as shown below:");
    printf("\n\n                       COPY  O_USER.CTL  _USER.CTL");
    printf(  "\n                       COPY  O_USER.IDX  _USER.IDX");
    sleep(5);
    printf("\n\nConstructing new index: %s_USER.IDX\n\n",lan_path);
    sprintf(inp_file,"%sO_USER.CTL",lan_path);
    if ((inp_fileh = _open(inp_file,O_RDWR)) < 0) {
	build_error(lan_path,"O_USER.CTL",TRUE);
	return;
    }
    fcb = allocate_fcb();
    p = fcb->user_rec;
    fcb->dat_recsize = sizeof(USER_RECORD);
    fcb->dat_keypos = 1;
    fcb->dat_keytype = 0;
    strcpy(fcb->dram_path,lan_path);
    dram_slasher(fcb);
    strcpy(fcb->dram_fname,"_USER");
    if (dram(CREATE,fcb)) {
	printf("ERROR: Cannot create DRAM index and data file: %Fs%Fs",fcb->dram_path,fcb->dram_fname);
	pause_to_read(TRUE);
	goto Conex;
    }
    flen = filelength(inp_fileh);
    fpos = (LONGINTEGER) sizeof(USER_RECORD);
    count = 0;
    seekfile(inp_fileh,0L,SEEK_SET);
    readfile(inp_fileh,(char*) p,sizeof(USER_RECORD));
    p->user_deleted = 0;
//      strcpy(p->user_name,"SYS CTL");
//      strcpy(p->user_first_date,date2000());
//      strcpy(p->user_first_time,gttime());
    seekfile(fcb->dat_handle,0L,SEEK_SET);
    writefile(fcb->dat_handle,(char *) p,sizeof(USER_RECORD));
    while (fpos < flen) {
	seekfile(inp_fileh,fpos,SEEK_SET);
	readfile(inp_fileh,(char*) p,sizeof(USER_RECORD));
	if ((remove_dels) && (p->user_deleted)) {
CleanOut_Mailbox:
            erase_mailbox(p,p->user_caller_no);
	    goto Skip_user;
        }
	expire_daynumber = 0;
	if ((p->nf_expire_date[0]>='0')&&(p->nf_expire_date[0]<='9'))
	    expire_daynumber = (int)(daynumber(p->nf_expire_date) - curr_daynumber);
	days_since_last_on = (int)(curr_daynumber - daynumber(p->nf_last_date));
	if (remove_expired) {
	    if ((expire_daynumber<0)&&((abs(expire_daynumber))>expire_limit)){
		strcpy(inp,"calls");
		if (p->user_total_calls==1)
		    inp[4]=0;
		printf("EXPIRED: %-31Fs %5d days ago, %4ld %s\n",
                    p->user_name,days_since_last_on,p->user_total_calls,inp);
		delay(1000);
		goto CleanOut_Mailbox;
	    }
	}
	if (trash_removal) {
	    bad_one = 0;
	    if ((p->nf_privel < '0')||(p->nf_privel > 'z'))
		bad_one++;
	    strcpy(inp,p->user_password);
	    if ((strlen(inp)) < 4)
		bad_one++;
	    strcpy(inp,p->user_city_state_zip);
	    if ((strlen(inp)) < 5)
		bad_one++;
	    strcpy(inp,p->user_name);
	    if ((strlen(inp)) < 5)
		bad_one++;
	    if (expire_daynumber < (-30))
		bad_one++;
	    strcpy(inp,p->user_password);
	    bad_one += flake_scan(inp);
	    strcpy(inp,p->user_name);
	    bad_one += flake_scan(inp);
	    strcpy(inp,p->user_city_state_zip);
	    if (flake_scan(inp)) {
		if (!bad_one) {
		    printf("\nCaller Name  : %s",p->user_name);
		    printf("\nCity & State : %s",p->user_city_state_zip);
		    printf("\n Correction? : ");
		    gets(inp);
		    printf("\n");
		    if (inp[0]) {
			strcpy(p->user_city_state_zip,inp);
			proper(p->user_city_state_zip);
                        postal_code_adj(p->user_city_state_zip);
		    }
		    else {
			bad_one = 1;
		    }
		}
		else {
		    bad_one++;
		}
	    }
	    if (bad_one) {
		printf("\n\nCaller Name    : %s",p->user_name);
		printf(  "\nPassword       : %s",p->user_password);
		printf(  "\nAccess Level   : %c",(int) p->nf_privel);
		printf(  "\nCity & State   : %s",p->user_city_state_zip);
                printf(  "\nNo. of calls   : %ld",p->user_total_calls);
                printf(  "\nLast called on : %s",fmt_date2000(p->nf_last_date));
		printf(  "\nExpire Date    : %s",fmt_date2000(p->nf_expire_date));
		if (expire_daynumber < 0)
		    printf("      EXPIRED!");
		printf("\n\n(D) delete account\n(E) erase expire date\n(I) issue new expire date : ");
		up_gets(inp);
		printf("\n");
		if ((inp[0] == 'Y') || (inp[0] == 'D'))
		    goto CleanOut_Mailbox;
                if (inp[0] == 'E')
                    p->nf_expire_date[0] = 0;
                if (inp[0] == 'I') {
//***************************************************************************
                    strcpy(s,fmt_date2000(p->nf_expire_date));
                    string_ed("Expire Date ........... %s\n",(-1),s,10);
                    if (is_blank_line(s))
                        p->nf_expire_date[0] = 0;
                    else
                        cvt_to_date2000(p->nf_expire_date,s);
//***************************************************************************
                    printf("Expiry Access Level ... %c\n",(int) p->user_expired_privel);
                    s[0] = (char) p->user_expired_privel;
                    s[1] = 0;
                    str_input(s,"                        ",1);
                    if (s[0])
                    p->user_expired_privel = s[0];
//***************************************************************************
                }
	    }
	}
	if (date_purge) {
	    if ((p->user_banned)
		|| (p->nf_privel <= privel_override)
		    || (p->user_total_calls >= call_override))
			goto Keeper;
	    if (days_since_last_on <= day_override)
		goto Keeper;
	    strcpy(inp,"calls");
	    if (p->user_total_calls == 1)
		inp[4]=0;
	    printf("INACTIVE: %-31Fs %5d days ago, %4ld %s\n",
                p->user_name,days_since_last_on,p->user_total_calls,inp);
	    goto CleanOut_Mailbox;
	}
Keeper:
	strcpy(fcb->string_key,p->user_name);
	fcb->binary_key = p->user_caller_no;
	if (dram(APPEND,fcb))
	    printf("Unable to add \"%Fs\", possible duplicate record.\n",p->user_name);
	else {
	    if (!(++count % 25))
		printf("%5ld.  %-32Fs%-32Fs\n",count,p->user_name,p->user_city_state_zip);
	}
Skip_user:
	fpos += (LONGINTEGER) sizeof(USER_RECORD);
    }
    dram(CLOSE,fcb);
Conex:
    release_fcb(fcb);
    fcb=NULL;
    _close(inp_fileh);
}

void generate_user_msg_report(char *msg_path)
{
    LONGINTEGER fpos, flen;
    int inp_fileh, banned;
    unsigned recno;
    char inp[128];
    char inp_file[128];
    char home_directory[128];
    char curr_directory[128];
    FILE *user_report;
    char user_report_fname[128];
    DRAM *ufcb;
    USER_RECORD *up;
    USER_MSG_RECORD mp;

    ufcb=NULL;
    getcwd(home_directory,80);
    strcpy(curr_directory,msg_path);
    strupr(curr_directory);
    if (chg_dir(curr_directory)) {
	printf("\nCannot access %s",curr_directory);
	sleep(5);
	return;
    }
    sprintf(inp_file,"%sUSER_MSG.CTL",msg_path);
    if ((inp_fileh = _open(inp_file,O_RDWR)) < 0) {
	printf("\nCannot access %s",inp_file);
	sleep(5);
	goto Conex3;
    }
    ufcb = allocate_fcb();
    up = ufcb->user_rec;
    ufcb->dat_recsize = sizeof(USER_RECORD);
    ufcb->dat_keypos = 1;
    ufcb->dat_keytype = 0;
    strcpy(ufcb->dram_path,lan_path);
    dram_slasher(ufcb);
    strcpy(ufcb->dram_fname,"_USER");
    if (dram(OPEN,ufcb)) {
	printf("\nERROR: Cannot open index and data file: %Fs%s\n",ufcb->dram_path,"_USER");
	sleep(5);
	goto Conex2;
    }
    sprintf(user_report_fname,"%sUSER_MSG.RPT",msg_path);
    if ((user_report = fopen(user_report_fname,"wt")) == NULL) {
	printf("\nERROR: cannot open %s",user_report_fname);
	sleep(5);
	return;
    }
    strcpy(inp,gttime());
    inp[5] = 0;
    printf("\nReport is going to file %s",user_report_fname);
    fprintf(user_report,"User Msg List  %s %s\n\n",date(),inp);
    fprintf(user_report,
" No.      Caller Name                    City-State                  1st Call\n");
    fprintf(user_report,
"----   ------------------------------ ------------------------------ --------\n");
    flen = filelength(inp_fileh);
    fpos = (LONGINTEGER) sizeof(USER_MSG_RECORD);
    seekfile(inp_fileh,0L,SEEK_SET);
    readfile(inp_fileh,(char*) &mp,sizeof(USER_MSG_RECORD));
    recno = 0;
    while (fpos < flen) {
        seekfile(inp_fileh,fpos,SEEK_SET);
	readfile(inp_fileh,(char*) &mp,sizeof(USER_MSG_RECORD));
	if (!(mp.user_msg_deleted)) {
	    if (!(++recno % 25))
		printf(".");
	    ufcb->hash_key = mp.user_msg_hash_code;
	    ufcb->binary_key = mp.user_msg_caller_no;
	    if (! dram(HASH_READ,ufcb)) {
		banned = ' ';
		if (mp.user_msg_banned)
		    banned = '*';
		fprintf(user_report,"%4u. %c%-31Fs%-31Fs%s\n",
		    recno,
		     banned,
		      up->user_name,
		       up->user_city_state_zip,
			fmt2_date2000(up->nf_first_date));
	    }
	}
	fpos += (LONGINTEGER) sizeof(USER_MSG_RECORD);
    }
    dram(CLOSE,ufcb);
    fclose(user_report);
Conex2:
    release_fcb(ufcb);
    ufcb=NULL;
    _close(inp_fileh);
Conex3:
    chg_dir(home_directory);
}

void generate_user_report(char *msg_path)
{
    LONGINTEGER fpos, flen;
    int inp_fileh, detailed, subscription_report;
    int minimum_days;
    unsigned counter, usr_banned;
    LONGINTEGER ratio_k, ratio_f;
    FILE *user_report;
    INTEGER curr_daynumber;
    int days_left;
    char inp_file[128], user_report_fname[128], inp[128];
    USER_RECORD p;

    clrscr();
    curr_daynumber = daynumber(date2000());
    printf("\nDo you want the message area report?  [y/N] ");
    up_gets(inp);
    if (inp[0]=='Y') {
	generate_user_msg_report(msg_path);
	return;
    }
    subscription_report = detailed = 0;
    printf("\nDo you want a detailed report?        [y/N] ");
    up_gets(inp);
    if (inp[0]=='Y') {
	detailed=1;
	printf("\nDo you want a subscription report?    [y/N] ");
	up_gets(inp);
	if (inp[0]=='Y') {
	    subscription_report = 1;
	    printf("\n    How near the expiration date in days?  ");
	    gets(inp);
	    minimum_days = atoi(inp);
	}
    }
    if (subscription_report)
	sprintf(user_report_fname,"%sSUBS.RPT",gtpath);
    else
	sprintf(user_report_fname,"%sUSER.RPT",gtpath);
    if ((user_report = fopen(user_report_fname,"wt")) == NULL) {
	printf("\nERROR: cannot open %s",user_report_fname);
	sleep(5);
	return;
    }
    strcpy(inp,gttime());
    counter =
     inp[5] = 0;
    printf("\nReport is going to file %s",user_report_fname);
    if (subscription_report)
	fprintf(user_report,"\nNear Expiration Date Report      %s %s\n\n",
	    date(),inp);
    else
	fprintf(user_report,"\nUser List      %s %s\n\n",date(),inp);
    fprintf(user_report,
" No.     Caller Name                    City-State                 1st Call \n");
    fprintf(user_report,
"----  ------------------------------ ---------------------------- ----------\n");
    sprintf(inp_file,"%s_USER.CTL",lan_path);
    if ((inp_fileh = _open(inp_file,o_mode(O_RDWR))) < 0) {
	build_error(lan_path,"_USER.CTL",TRUE);
	fclose(user_report);
	return;
    }
    flen = filelength(inp_fileh);
    fpos = (LONGINTEGER) sizeof(USER_RECORD);
    while (fpos < flen) {
        seekfile(inp_fileh,fpos,SEEK_SET);
	readfile(inp_fileh,(char*) &p,sizeof(USER_RECORD));
	if (p.user_deleted)
	    goto Loop_user;
	if (!(++counter % 25))
	    printf(".");
	if (subscription_report) {
	    if ((p.nf_expire_date[0]<'0')||(p.nf_expire_date[0]>'9'))
		goto Loop_user;
	    days_left = (int)(daynumber(p.nf_expire_date) - curr_daynumber);
	    if (days_left > minimum_days)
		goto Loop_user;
	}
        p.user_city_state_zip[28] = 0;
	fprintf(user_report,"%4u. %-30s %-28s %s\n",
	    counter,
	    p.user_name,
	    p.user_city_state_zip,
	    fmt2_date2000(p.nf_first_date));
	if (!detailed)
	    goto Loop_user;
	usr_banned = 'F';
	if (p.user_banned)
	    usr_banned = 'T';
        fprintf(user_report,"        Class:%c  Ph#:%-15s Pwd:%-16s  Calls: %-4lu ",
	       (int) p.nf_privel,
	       p.nf_phone,
	       p.user_password,
               p.user_total_calls);
        if (usr_banned == 'T')
            fprintf(user_report,"BANNED");
        fprintf(user_report,"\n");
	ratio_k = p.user_total_dnload_k;
	ratio_f = p.user_total_dnload_files;
	if ((p.user_total_upload_k > 0) && (p.user_total_upload_files > 0)) {
	    ratio_k = p.user_total_dnload_k / p.user_total_upload_k;
	    ratio_f = p.user_total_dnload_files / p.user_total_upload_files;
	}
        fprintf(user_report,"        Net Credits :%-5lu  D/L Kilo:%-6lu  Files:%-5u   Ratios Kilo=%lu\n",
	       p.user_netmail_credits,
	       p.user_total_dnload_k,
	       p.user_total_dnload_files,
	       ratio_k);
        fprintf(user_report,"        Net Charges :%-5lu  U/L Kilo:%-6lu  Files:%-5u          File=%lu\n",
	       p.user_netmail_charges,
	       p.user_total_upload_k,
	       p.user_total_upload_files,
	       ratio_f);
	if ((p.nf_expire_date[0]>='0')&&(p.nf_expire_date[0]<='9')) {
	    days_left = (int)(daynumber(p.nf_expire_date) - curr_daynumber);
	    fprintf(user_report,"        Expire Date:%s    Days left:%d\n",
                fmt_date2000(p.nf_expire_date),days_left);
	}
	fprintf(user_report,"\n");
Loop_user:
	fpos += (LONGINTEGER) sizeof(USER_RECORD);
    }
Conex:
    _close(inp_fileh);
    fclose(user_report);
    sleep(2);
}

void issue_exp_dates(void)
{
    LONGINTEGER fpos, flen;
    int inp_fileh, override;
    int default_days, cvt_count;
    INTEGER dwork;
    LONGINTEGER match_privel;
    char inp_file[128], inp[128];
    USER_RECORD usr;

    clrscr();
    printf("\nWhich access level to process?                    (*=ALL)  ");
    gets(inp);
    trim(inp);
    if (! inp[0])
	return;
    match_privel = inp[0];
TryAgain:
    printf("\nHow many days from LAST CALL to give as subscription?      ");
    gets(inp);
    trim(inp);
    if (! inp[0])
	return;
    default_days = atoi(inp);
    if (default_days < 30) {
	printf("\n      Are you sure?  Only %d days!   [y/N]  ",default_days);
	up_gets(inp);
	if (inp[0] != 'Y')
	    goto TryAgain;
    }
    override = 0;
    printf("\nDo you wish to override existing expiration dates?  [y/N]  ");
    up_gets(inp);
    trim(inp);
    if (inp[0] == 'Y')
	override = 1;
    sprintf(inp_file,"%s_USER.CTL",lan_path);
    if ((inp_fileh = _open(inp_file,o_mode(O_RDWR))) < 0) {
	build_error(lan_path,"_USER.CTL",TRUE);
	return;
    }
    flen = filelength(inp_fileh);
    fpos = (LONGINTEGER) sizeof(USER_RECORD);
    cvt_count = 0;
    while (fpos < flen) {
        seekfile(inp_fileh,fpos,SEEK_SET);
	readfile(inp_fileh,(char*) &usr,sizeof(USER_RECORD));
	if (usr.user_deleted)
	    goto Issue_Loop;
        if (!override) {
	    if ((usr.nf_expire_date[0]>='0')&&(usr.nf_expire_date[0]<='9'))
	        goto Issue_Loop;
        }
	if ((match_privel!='*')&&(usr.nf_privel!=match_privel))
	    goto Issue_Loop;
        dwork = daynumber(usr.nf_last_date) + default_days;
	strcpy(usr.nf_expire_date,calcdate(dwork));
	seekfile(inp_fileh,fpos,SEEK_SET);
	writefile(inp_fileh,(char *) &usr,sizeof(USER_RECORD));
        cvt_count++;
Issue_Loop:
	fpos += (LONGINTEGER) sizeof(USER_RECORD);
    }
    _close(inp_fileh);
    if (cvt_count) {
	printf("\n\n%d expiration dates converted.\n",cvt_count);
	delay(4000);
    }
}

void clean_up_user_msg_file(char *msg_path,int rebuild_board_joins)
{
    LONGINTEGER fpos, flen;
    int inp_fileh, recno;
    char *p;
    char inp[128];
    char inp_file[128];
    char home_directory[128];
    char curr_directory[128];
    char old_user_msg_idx[128];
    char old_user_msg_ctl[128];
    DRAM *ufcb;
    USER_RECORD *up;
    DRAM *mfcb;
    USER_MSG_RECORD *mp;

    ufcb =
      mfcb = NULL;
    getcwd(home_directory,80);
    strcpy(curr_directory,msg_path);
    strupr(curr_directory);
    if (chg_dir(curr_directory)) {
	printf("\nCannot access %s",curr_directory);
	prt_line();
	sleep(1);
	return;
    }
    printf("\n");
    p = backup_file(msg_path,"USER_MSG","IDX","O_USRMSG");
    strcpy(old_user_msg_idx,p);
    p = backup_file(msg_path,"USER_MSG","CTL","O_USRMSG");
    strcpy(old_user_msg_ctl,p);
    printf(  "\nIf this process does not complete successfully, the USER_MSG files can");
    printf(  "\nbe recovered by copying files as shown below:");
    printf("\n\n                   COPY  O_USRMSG.CTL  USER_MSG.CTL");
    printf(  "\n                   COPY  O_USRMSG.IDX  USER_MSG.IDX");
    printf("\n\nThese files are located in the subdirectory: %s",msg_path);
    sleep(2);
    printf("\n\nConstructing new index: %sUSER_MSG.IDX\n",msg_path);
    sprintf(inp_file,"%sO_USRMSG.CTL",msg_path);
    if ((inp_fileh = _open(inp_file,O_RDWR)) < 0) {
	build_error(msg_path,"O_USRMSG.CTL",FALSE);
	sleep(5);
	goto Conex3;
    }
    mfcb = allocate_fcb();
    mp = mfcb->user_msg_rec;
    mfcb->dat_recsize = sizeof(USER_MSG_RECORD);
    mfcb->dat_keypos = 5;
    mfcb->dat_keytype = 1;
    strcpy(mfcb->dram_path,msg_path);
    dram_slasher(mfcb);
    strcpy(mfcb->dram_fname,"USER_MSG");
    if (dram(CREATE,mfcb)) {
	printf("ERROR: Cannot create DRAM index and data file: %Fs%Fs",mfcb->dram_path,mfcb->dram_fname);
	sleep(5);
	goto Conex2;
    }
    ufcb = allocate_fcb();
    up = ufcb->user_rec;
    ufcb->dat_recsize = sizeof(USER_RECORD);
    ufcb->dat_keypos = 1;
    ufcb->dat_keytype = 0;
    strcpy(ufcb->dram_path,lan_path);
    dram_slasher(ufcb);
    strcpy(ufcb->dram_fname,"_USER");
    if (dram(OPEN,ufcb)) {
	printf("\nERROR: Cannot open DRAM index and data file: %Fs%s\n",ufcb->dram_path,"_USER");
	dram(CLOSE,mfcb);
	sleep(5);
	goto Conex2;
    }
    flen = filelength(inp_fileh);
    fpos = (LONGINTEGER) sizeof(USER_MSG_RECORD);
    seekfile(inp_fileh,0L,SEEK_SET);
    readfile(inp_fileh,(char*) mp,sizeof(USER_MSG_RECORD));
    seekfile(mfcb->dat_handle,0L,SEEK_SET);
    writefile(mfcb->dat_handle,(char *) mp,sizeof(USER_MSG_RECORD));
    recno = 0;
    while (fpos < flen) {
	seekfile(inp_fileh,fpos,SEEK_SET);
	readfile(inp_fileh,(char*) mp,sizeof(USER_MSG_RECORD));
	if (!(mp->user_msg_deleted)) {
	    ufcb->hash_key = mp->user_msg_hash_code;
	    ufcb->binary_key = mp->user_msg_caller_no;
	    if (! dram(HASH_READ,ufcb)) {
		if (!(++recno % 25))
		    printf("\n%5d.  %-32Fs%-32Fs",recno,up->user_name,up->user_city_state_zip);
		if (mp->user_msg_banned) {
		    printf("\n\nCaller Name  : %Fs",up->user_name);
		    printf(  "\nPassword     : %Fs",up->user_password);
		    printf(  "\nAccess Level : %c",(int) up->nf_privel);
		    printf(  "\nCity & State : %Fs",up->user_city_state_zip);
		    printf("\n\nRemove the msg base ban from this user in %s? [y/N]  ",curr_directory);
		    up_gets(inp);
		    printf("\n");
		    if (inp[0] == 'Y')
			mp->user_msg_banned = 0;
		}
		strcpy(mfcb->string_key,up->user_name);
		mfcb->binary_key = up->user_caller_no;
		if (rebuild_board_joins)
		    root = tree(root,up->user_caller_no,up->user_hash_code);
		dram(APPEND,mfcb);
	    }
	}
	fpos += (LONGINTEGER) sizeof(USER_MSG_RECORD);
    }
    dram(CLOSE,ufcb);
    dram(CLOSE,mfcb);
    unlink(old_user_msg_idx);
    unlink(old_user_msg_ctl);
Conex2:
    release_fcb(ufcb);
    release_fcb(mfcb);
    ufcb =
      mfcb = NULL;
    _close(inp_fileh);
Conex3:
    chg_dir(home_directory);
    prt_line();
}

void clean_up_board_joins(char *board_name)
{
    DRAM *ufcb;
    char bd_name[80];
    char f_name[80];
    char j_dname[80];
    int data_changed;
    int read_amt, max_callers, join_file, j;
    long seek_adr;
    INTEGER counter;

    if ((!board_name[0]) || (board_name[0]==' '))
	return;
    strcpy(bd_name,board_name);
    bd_name[8] = 0;
    data_changed = FALSE;
    strupr(bd_name);
    select_path(j_dname);
    sprintf(f_name,"%s\\%s.CTL",j_dname,bd_name);
    join_file = _open(f_name,o_mode(O_RDWR));
    if (join_file < 0)
	return;
    seek_adr = 0L;
    ufcb = NULL;
    ufcb = allocate_fcb();
    ufcb->dat_recsize = sizeof(USER_RECORD);
    ufcb->dat_keypos = 1;
    ufcb->dat_keytype = 0;
    strcpy(ufcb->dram_path,lan_path);
    dram_slasher(ufcb);
    strcpy(ufcb->dram_fname,"_USER");
    if (dram(OPEN,ufcb)) {
	printf("\nERROR: Cannot open DRAM index and data file: %Fs%s\n",ufcb->dram_path,"_USER");
	sleep(5);
	goto CleanJoinEx;
    }
    printf("\nCleaning up the joins for the %s board.\n",board_name);
    counter = 0;
    do {
	read_amt = _read(join_file,&callers,2048);
	if (read_amt > 0) {
	    max_callers = (read_amt >> 3);
	    for (j=0; j<max_callers; j++) {
		if (!(++counter % 25))
		    printf(".");
		if (callers[j].CallerNumber != 0L) {
		    ufcb->hash_key = (INTEGER) callers[j].HashCode;
		    ufcb->binary_key = callers[j].CallerNumber;
		    if (dram(HASH_READ,ufcb)) {
			callers[j].CallerNumber = 0L;
			callers[j].HashCode = 0;
			data_changed = TRUE;
			printf("-");
		    }
		}
	    }
	    if (data_changed) {
		lseek(join_file,seek_adr,SEEK_SET);
		_write(join_file,&callers,read_amt);
		data_changed = FALSE;
	    }
	}
	seek_adr += 2048L;
    } while (read_amt > 0);
    _close(join_file);
    dram(CLOSE,ufcb);
    printf("\n");
CleanJoinEx:
    release_fcb(ufcb);
    ufcb = NULL;
}

void re_organize(void)
{
    DRAM *fcb;

    fcb = allocate_fcb();
    fcb->dat_recsize = sizeof(USER_RECORD);
    fcb->dat_keypos = 1;
    fcb->dat_keytype = 0;
    strcpy(fcb->dram_path,lan_path);
    dram_slasher(fcb);
    strcpy(fcb->dram_fname,"_USER");
    if (dram(OPEN,fcb)) {
	import_error("_USER",lan_path);
	return;
    }
    dram(PURGE,fcb);
    dram(CLOSE,fcb);
    release_fcb(fcb);
    fcb=NULL;
}

void expand_msg_idx(char *msg_path)
{
    DRAM *fcb;

    fcb = allocate_fcb();
    fcb->dat_recsize = sizeof(USER_MSG_RECORD);
    fcb->dat_keypos = 5;
    fcb->dat_keytype = 1;
    strcpy(fcb->dram_path,msg_path);
    dram_slasher(fcb);
    strcpy(fcb->dram_fname,"USER_MSG");
    if (dram(OPEN,fcb)) {
	import_error("USER_MSG",msg_path);
	return;
    }
    idx_expand(fcb);
    dram(CLOSE,fcb);
    release_fcb(fcb);
    fcb=NULL;
}

void main(void)
{
    FILE *text;
    char wrk[514];
    char inp[80];
    char curr_msg_path[128];
    char *ep;
    int ramt, j;

    TZ();
    default_msg_path[0] = 0;
    if ((ep = getenv("GTPATH")) != NULL)
	strcpy(gtpath,ep);
    else
	getcwd(gtpath,80);
    process_pathname(gtpath);
    strcpy(bbs_path,gtpath);
    strcpy(lan_path,gtpath);
    sprintf(wrk,"%sGT.CNF",gtpath);
    if ((text = fopen(wrk,"rt")) != NULL) {
	do {
	    if ((ramt = fgets_p(wrk,512,text)) > 0) {
		strupr(wrk);
		if ((wrk[2] == '=') && (wrk[3] >= 'A') && (wrk[3] <= 'Z')) {
		    if ((wrk[0] == 'M') && (wrk[1] == 'P')) {
		        strcpy(default_msg_path,&wrk[3]);
		        process_pathname(default_msg_path);
			continue;
                    }
		    if ((wrk[0] == 'B') && (wrk[1] == 'B')) {
			strcpy(bbs_path,&wrk[3]);
			process_pathname(bbs_path);
			continue;
		    }
                    if ((wrk[0] == 'M') && (wrk[1] == 'A')) {
                        strcpy(mailbox_dir,&wrk[3]);
                        process_pathname(mailbox_dir);
                        continue;
                    }
		    if ((wrk[0] == 'L') && (wrk[1] == 'R')) {
			strcpy(lan_path,&wrk[3]);
			process_pathname(lan_path);
			continue;
		    }
		}
	    }
	} while (ramt >= 0);
	fclose(text);
    }
    clrscr();
    printf("\nGT POWER Sysop Program 4.0");
    printf("\n(C) 1988, 1994 P&M Software Company");
    printf("\nAll Rights Reserved");
    printf("\n");
    for (j=0; j<30; j++) {
	delay(100);
	if (kbhit()) {
	    getch();
	    break;
	}
    }
    strcpy(curr_msg_path,default_msg_path);
    strupr(curr_msg_path);
    inp[0]=0;
    while (inp[0] != 'Q') {
	clrscr();
        printf(  "Main Menu                            GTPATH  : %s",gtpath);
	printf("\n---------                            Msg Base: %s\n",curr_msg_path);
	printf("\n 1.  (I)mport control files from 15.00 thru 18.00.");
	printf("\n 2.  (A)dd user records.");
	printf("\n 3.  Delete (U)ser records.");
	printf("\n 4.  (D)elete messages.");
	printf("\n 5.  (R)enumber messages.");
	printf("\n 6.  (L)ookup/edit user records.");
	printf("\n 7.  (G)oto/edit user records.");
	printf("\n 8.  Re-(O)rganize _USER index file.");
	printf("\n 9.  (E)xamine lost user record.");
	printf("\n10.  Expand USER_MSG index file.");
	printf("\n11.  Clean-up _USER control file.");
	printf("\n12.  Clean-up USER_MSG index file.");
	printf("\n13.  Global access level change.");
	printf("\n14.  Make a message (S)ticky.");
	printf("\n15.  Mass issue E(x)piration dates.");
	printf("\n16.  Change the msg base (P)ath.");
	printf("\n17.  Ge(n)erate User Reports.");
        printf("\n18.  (C)lear Peak/Off-Peak accounting totals.");
	printf("\n19.  (Q)uit the program.");
	printf("\n\nWhich command? ");
Bksp:
	inp[0] = my_getkey(1);
	inp[1] = 0;
	strupr(inp);
	if (inp[0] == '\x08')
	    goto Bksp;
	if (inp[0] == '1') {
	    inp[1] = my_getkey(0);
	    inp[2] = 0;
	    if (inp[1] == '\x08')
		goto Bksp;
            if (inp[1] == '\r')
                inp[1] = 0;
	}
	printf("\n");
	if ((! strcmp(inp,"1"))||(inp[0]=='I')) {
	    build_ctl();
	    continue;
	}
	if ((! strcmp(inp,"2"))||(inp[0]=='A')) {
	    add_user();
	    continue;
	}
	if ((! strcmp(inp,"3"))||(inp[0]=='U')) {
	    delete_user();
	    continue;
	}
	if ((! strcmp(inp,"4"))||(inp[0]=='D')) {
            scan_msg_bases(1);
	    continue;
	}
	if ((! strcmp(inp,"5"))||(inp[0]=='R')) {
	    scan_msg_bases(2);
	    continue;
	}
	if ((! strcmp(inp,"6"))||(inp[0]=='L')) {
	    find_user(0,curr_msg_path);
	    continue;
	}
	if ((! strcmp(inp,"7"))||(inp[0]=='G')) {
	    find_user(1,curr_msg_path);
	    continue;
	}
	if ((! strcmp(inp,"8"))||(inp[0]=='O')) {
	    re_organize();
	    continue;
	}
	if ((! strcmp(inp,"9"))||(inp[0]=='E')) {
	    examine_lost();
	    continue;
	}
	if (! strcmp(inp,"10")) {
	    expand_msg_idx(curr_msg_path);
	    continue;
	}
	if (! strcmp(inp,"11")) {
	    clean_up_user_file();
	    continue;
	}
	if (! strcmp(inp,"12")) {
	    scan_msg_bases(3);
	    continue;
	}
	if (! strcmp(inp,"13")) {
	    global_access_lvl_chg();
	    continue;
	}
	if ((! strcmp(inp,"14"))||(inp[0]=='S')) {
	    make_a_msg_sticky(curr_msg_path);
	    continue;
	}
	if ((! strcmp(inp,"15"))||(inp[0]=='X')) {
	    issue_exp_dates();
	    continue;
	}
	if ((! strcmp(inp,"16"))||(inp[0]=='P')) {
	    getcwd(wrk,80);
	    printf("\nEnter new msg base path : ");
	    up_gets(inp);
            process_pathname(inp);
	    if (chg_dir(inp)) {
		printf("\nCannot access %s",inp);
		sleep(3);
	    }
	    else {
		getcwd(curr_msg_path,80);
	        chg_dir(wrk);
	        process_pathname(curr_msg_path);
	    }
	    continue;
	}
	if ((! strcmp(inp,"17"))||(inp[0]=='N')) {
	    generate_user_report(curr_msg_path);
	    continue;
	}
        if ((!strcmp(inp,"18"))||(inp[0]=='C')) {
            clear_acctng_totals();
            continue;
        }
	if ((!strcmp(inp,"19"))||(inp[0]=='Q')) {
	    clrscr();
	    inp[0] = 'Q';
	}
    }
    exit(0);
}
